Scriptname JB:JBCompatibilityQuestScript extends Quest



FormList Property JBRestrictList Auto Const

Message Property JBRestrictListResetMSG Auto Const
Message Property JBTortureDevicesInstalledMSG Auto Const
Message Property JBCrimsomriderUniqueFurnitureInstalledMSG Auto Const
Message Property JBPrisonerShacklesInstalledMSG Auto Const

Group ModGroup
	String Property TortureDevices = "TortureDevices.esm" Auto Const
	Bool Property TortureDevicesInstalled = false Auto

	String Property CrimsomriderUniqueFurniture = "Crimsomrider's Unique Furniture.esp" Auto Const
	Bool Property CrimsomriderUniqueFurnitureInstalled = false Auto

	String Property PrisonerShackles = "Prisoner Shackles.esp" Auto Const
	Bool Property PrisonerShacklesInstalled = false Auto
EndGroup


Event OnInit()
	RegisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")
	Update()
EndEvent

Event Actor.OnPlayerLoadGame(actor aSender)
	Update()
EndEvent

Function Update()
	If !Game.IsPluginInstalled(TortureDevices) && TortureDevicesInstalled
		ResetRestrictList()
	ElseIf !Game.IsPluginInstalled(CrimsomriderUniqueFurniture) && CrimsomriderUniqueFurnitureInstalled
		ResetRestrictList()
	ElseIf !Game.IsPluginInstalled(PrisonerShackles) && PrisonerShacklesInstalled
		ResetRestrictList()
	EndIf
	Utility.Wait(0.3)
	If Game.IsPluginInstalled(TortureDevices) && !TortureDevicesInstalled
		LoadTortureDevices()
	EndIf
	If Game.IsPluginInstalled(CrimsomriderUniqueFurniture) && !CrimsomriderUniqueFurnitureInstalled
		LoadCrimsomriderUniqueFurniture()
	EndIf
	If Game.IsPluginInstalled(PrisonerShackles) && !PrisonerShacklesInstalled
		LoadPrisonerShackles()
	EndIf
EndFunction

Function LoadTortureDevices()
	;Debug.Notification("TortureDevices Added")
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00001737, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000173C, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00001ED6, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00002681, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00003D4B, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00003D4C, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00004C99, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000543B, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000543C, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000072C0, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000081EB, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00008989, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000098C7, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000098CA, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000A802, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000A804, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000AFA3, TortureDevices))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000AFA4, TortureDevices))
	TortureDevicesInstalled = true
	JBTortureDevicesInstalledMSG.Show()
EndFunction

Function LoadCrimsomriderUniqueFurniture()
	;Debug.Notification("CrimsomriderUniqueFurniture Added")
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AC7, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AC8, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AC9, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6ACD, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6ACF, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AD1, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AD7, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AD8, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000E6AD9, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000EAF2B, CrimsomriderUniqueFurniture))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000EF37D, CrimsomriderUniqueFurniture))
	CrimsomriderUniqueFurnitureInstalled = true
	JBCrimsomriderUniqueFurnitureInstalledMSG.Show()
EndFunction

Function LoadPrisonerShackles()
	;Debug.Notification("PrisonerShackles Added")
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000018CF, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000029A3, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000042D7, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CDA, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CDC, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CDE, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CE3, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CE5, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00006CE6, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000754F, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00008632, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000096FE, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x000096FF, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x00009704, PrisonerShackles))
	JBRestrictList.AddForm(Game.GetFormFromFile(0x0000970C, PrisonerShackles))
	PrisonerShacklesInstalled = true
	JBPrisonerShacklesInstalledMSG.Show()
EndFunction

Function ResetRestrictList()
	;Debug.Notification("RestrictList Reset")
	JBRestrictList.Revert()
	TortureDevicesInstalled = false
	CrimsomriderUniqueFurnitureInstalled = false
	PrisonerShacklesInstalled = false
	JBRestrictListResetMSG.Show()
EndFunction