Scriptname JB:JBHuntingQuestScript extends Quest


import RenameAnything

jb:jbslavequestscript Property JBSlaveQuest Auto Const Mandatory

;ReferenceAlias Property NameAlias Auto Const

Perk Property JBHuntingPerk Auto Const Mandatory

ActorValue property Assistance auto mandatory
ActorValue property Morality auto mandatory

Armor Property Collar Auto Const

Faction Property JBSlaveFaction auto mandatory

Message Property JBMsgSlaveActivate auto Const
;Message Property JBBlankMessage auto Const

Message Property JBHuntModeON Auto Const
Message Property JBHuntModeOFF Auto Const

Furniture Property PowerArmorFrameFurnitureNoCore Auto Const

ObjectReference Property JBdeadXRef Auto Const

bool Property RemoveCorpse = true Auto

;AAF:AAF_API AAF_API ;AAF


Function JBHunterModeSwitch()

	;If !Utility.IsInMenuMode() && !Game.GetPlayer().IsDead()
		
		Utility.Wait(0.1)
		
		If (Game.GetPlayer().HasPerk(JBHuntingPerk))
		
			Game.GetPlayer().RemovePerk(JBHuntingPerk)

			JBSlaveQuest.JBbIsHunterModeActivated = false
				
			;Debug.Notification("Hunter mode off")
			JBHuntModeOFF.Show()
			
		Else
		
			Game.GetPlayer().AddPerk(JBHuntingPerk)

			JBSlaveQuest.JBbIsHunterModeActivated = true
				
			;Debug.Notification("Hunter mode on")
			JBHuntModeON.Show()
		
		EndIf
		
	;EndIf

EndFunction	

Function victimClone(Actor akTarget)

	ActorBase baseClone = GetSlaveBase(akTarget)
	
	Actor akTargetClone = akTarget.PlaceAtMe(baseClone, 1, true, false, false) as Actor
	akTargetClone.SetAlpha(0)
	
	If !akTarget.GetActorBase().IsUnique()
		String name = akTarget.GetDisplayName()
		String cloneName = akTargetClone.GetDisplayName()
		If name && name != cloneName
			SetRefName(akTargetClone as ObjectReference, name)
			;JBBlankMessage.SetName(name)
			;NameAlias.ApplyToRef(akTargetClone)
		EndIf
	EndIf
	
	akTargetClone.RemoveAllItems()

	int index = 6
	;int index = 11
	int end = 15 const
	While index <= end
		Actor:WornItem wornItem = akTarget.GetWornItem(index)
		akTargetClone.EquipItem(wornItem.Item)
		index += 1
	EndWhile

	akTarget.RemoveAllItems(akTargetClone)
	;akTarget.SetOutfit(None)
	If akTarget.IsInPowerArmor()
		;Debug.Notification("IsInPowerArmor = true")
		ObjectReference pArmor = akTarget.PlaceAtMe(PowerArmorFrameFurnitureNoCore, 1, TRUE)
		akTargetClone.SwitchToPowerArmor(pArmor)
	EndIf
	akTargetClone.RemoveFromAllFactions()
	akTargetClone.SetValue(Game.GetAggressionAV(), -1)
	akTargetClone.SetValue(Morality, 0)
	akTargetClone.SetValue(Assistance, 0)
	akTargetClone.AddToFaction(JBSlaveFaction)
	;JBSlaveQuest.SetCommandMode(akTargetClone)
	akTargetClone.EquipItem(Collar, true)
	
	JBSlaveQuest.InitSlave(akTargetClone)
	
	akTargetClone.SetActivateTextOverride(JBMsgSlaveActivate)

	akTargetClone.Kill()

	Utility.Wait(2.0)

	akTargetClone.SetAlpha(1)
;	akTargetClone.StopCombatAlarm()
	akTargetClone.EvaluatePackage()

	akTargetClone.StopCombat()
	akTargetClone.StopCombatAlarm()
	
	akTarget.KillEssential()
	If (akTarget.IsDead() == True) && (RemoveCorpse == true)
		;Utility.Wait(0.3)
		;akTarget.RemoveAllItems(akTargetClone)
		;Utility.Wait(0.3)
		;akTarget.OpenInventory(true)
		akTarget.MoveTo(JBdeadXRef)
		akTarget.Disable()
		
	EndIf

EndFunction


ActorBase Function GetSlaveBase(Actor akTarget)
	ActorBase TargetBase = akTarget.GetLeveledActorBase().GetTemplate()
	If (!TargetBase)
		TargetBase = akTarget.GetActorBase()
	EndIf
	Return TargetBase
EndFunction

Function PlayerSlaveRape(Actor akSlave)
	akSlave.ResetHealthAndLimbs()
	akSlave.SetNoBleedoutRecovery(false)
	;Utility.Wait(5)
	Actor PlayerRef = Game.GetPlayer()
	bool inBleedOut = true
	While inBleedOut == true
		If akSlave.IsBleedingOut()
			;
		Else
			akSlave.StopCombat()
			akSlave.StopCombatAlarm()
			;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
			Actor[] actors = new Actor[2]
			actors[0] = PlayerRef
			actors[1] = akSlave

			JBSlaveQuest.StartSexScene(actors, akSlave)

			;AAF_API.QuickScene(actors, JBSlaveQuest.sexDuration, false)
			;four_play:Main.GetAPI().four_play(PlayerRef, akSlave, false ,akSlave, JBSlaveQuest.sexDuration) ;FP
			inBleedOut = false
		EndIf
	EndWhile
EndFunction

Function CompanionSlaveRape(Actor akSlave)
	akSlave.ResetHealthAndLimbs()
	akSlave.SetNoBleedoutRecovery(false)
	Actor CompanionRef = JBSlaveQuest.Companion.GetActorReference()
	bool inBleedOut = true
	While inBleedOut == true
		If akSlave.IsBleedingOut()
			;
		Else
			akSlave.StopCombat()
			akSlave.StopCombatAlarm()
			;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
			Actor[] actors = new Actor[2]
			actors[0] = CompanionRef
			actors[1] = akSlave

			JBSlaveQuest.StartSexScene(actors, akSlave)

			;AAF_API.QuickScene(actors, JBSlaveQuest.sexDuration, false)
			;four_play:Main.GetAPI().four_play(CompanionRef, akSlave, false ,akSlave, JBSlaveQuest.sexDuration) ;FP
			inBleedOut = false
		EndIf
	EndWhile
EndFunction

Function PlayerCompanionSlaveRape(Actor akSlave)
	akSlave.ResetHealthAndLimbs()
	akSlave.SetNoBleedoutRecovery(false)
	Actor PlayerRef = Game.GetPlayer()
	Actor CompanionRef = JBSlaveQuest.Companion.GetActorReference()
	bool inBleedOut = true
	While inBleedOut == true
		If akSlave.IsBleedingOut()
			;
		Else
			akSlave.StopCombat()
			akSlave.StopCombatAlarm()
			;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
			Actor[] actors = new Actor[3]
			actors[0] = PlayerRef
			actors[1] = akSlave
			actors[2] = CompanionRef

			JBSlaveQuest.StartSexScene(actors, akSlave)

			;AAF_API.QuickScene(actors, JBSlaveQuest.sexDuration, false)
			;four_play:Main.GetAPI().three_play(PlayerRef, akSlave, CompanionRef, akPreventBed=false, akVictim=none, duration = JBSlaveQuest.sexDuration) ;FP
			inBleedOut = false
		EndIf
	EndWhile
EndFunction
