Scriptname JB:JBSlaveQuestScript extends Quest Conditional


import WorkshopDataScript
import RenameAnything
import TIM:TIM

WorkshopParentScript Property WorkshopParent Auto Const Mandatory
DLC04:DLC04WorkshopParentScript Property DLC04WorkshopParent auto const mandatory

Group SlaveCollections

	RefCollectionAlias Property JBSlaveCollection Auto Const

	RefCollectionAlias Property JBSlaveFollowersCollection Auto Const

	RefCollectionAlias Property JBWorkshopSlaveCollection Auto Const

	RefCollectionAlias Property JBCaravanSlaveCollection Auto Const

	RefCollectionAlias Property JBProstituteSlaveCollection Auto Const

	ReferenceAlias[] Property JBSlaveFollower Auto Const

EndGroup

Struct SlaveData
	Actor Slave
	Int timer_id
EndStruct

Group SlaveData

	ActorValue Property JBbIsWorker Auto Conditional
	{
		0 - default
		1 - if this NPC is a worker of any kind
	}

	ActorValue Property JBIsWorkStatus Auto Conditional
	{
		0 - default
		1 - bIsGuard = True
		2 - bIsScavenger = True
		3 - Follow
		4 - Wait
		5 - GoHome
		6 - bIsProstitute = True
	}
	
	ActorValue Property JBbWork24Hours Auto Conditional
	
	ActorValue Property JBassignedMultiResource Auto
	
	ActorValue Property JBmultiResourceProduction Auto

	ActorValue Property JBslaveVendorType Auto Conditional

	ActorValue Property JBIsSubmissive Auto

	ActorValue Property JBSlaveSexSkill Auto

	ActorValue Property JBSlaveProstituteSkill Auto

	SlaveData[] Property SlavesData Auto

EndGroup

Group SlaveWorkObjectsData

	ReferenceAlias Property currentMultiResObject Auto Const

	Keyword Property JBSlaveWorkObject Auto Const

EndGroup

Group EscapeQuestData

	Quest Property JBEscapeQuest Auto Const

	ReferenceAlias Property runawaySlave Auto Const

EndGroup

Group QuartermasteryData

	Actor Property JBQuartermasteryBrahminRef Auto Const

	ReferenceAlias Property JBQuartermasteryAlias Auto Const
	
	ReferenceAlias Property JBQMBrahminAlias Auto Const

	Perk Property JBWorkshopBrahminPerk Auto Const

	Container Property JBQMTransferContainer Auto Const

EndGroup

Group Globals

	GlobalVariable Property JBbCountsForPopulation Auto Conditional
	{
		0 - don't count for total population
		1 - default
	}

	GlobalVariable Property JBSlaveTracking Auto Conditional

	;GlobalVariable Property JBAllowSettlerRename Auto Conditional

EndGroup

Group Keywords

	Keyword Property JBSlaveRestricted Auto Const

	Keyword Property JBCaravanBrahmin Auto Const

	;Keyword Property DLC05AnimFurnPillory Auto Const

EndGroup

Group Messages

	Message Property JBMsgSlaveActivate auto Const
	Message Property JBMsgProstituteActivate auto Const

	Message Property JBSlaveInfoMessageBox auto Const

	Message Property JBSlaveCountMSG Auto Const
	Message Property JBlabelNameMSG Auto Const
	Message Property JBlabelSubmissiveMSG Auto Const
	Message Property JBlabelSexSkillMSG Auto Const
	Message Property JBlabelProstituteSkillMSG Auto Const

	Message Property JBCountsForPopulationON Auto Const
	Message Property JBCountsForPopulationOFF Auto Const
	Message Property JBNeedsSubmissive50MSG Auto Const
	Message Property JBNeedsSubmissive80MSG Auto Const
	Message Property JBNeedsSubmissive100MSG Auto Const

	Message Property JBRenameLabel Auto Const

	Message Property JBSlaveRestrictedMSG Auto Const

	Message Property JBUpdateMSG Auto Const

	Message Property JBAskAboutFurnitureMSG Auto Const

	Message Property JBAskAboutPackagesMSG Auto Const

	Message Property JBRenameSettlersModeON Auto Const
	Message Property JBRenameSettlersModeOFF Auto Const

EndGroup

Group GameMods

	bool Property JBbIsHunterModeActivated = false Auto

	bool Property JBbIsTradeModeActivated = false Auto

	bool Property JBbIsRenameModeActivated = false Auto

EndGroup

Group Debug

	String Property userlogName = "JustBusiness" Auto Const Hidden

	String Property currentModVersion = "0.5.2" Auto Const

	String Property previousModVersion Auto

EndGroup

MiscObject Property Caps001 Auto Const

MagicEffect Property JBMarkEffect Auto Const

Faction Property JBSlaveFaction Auto Const

FormList Property JBRestrictList Auto Const

bool Property SlaveDontUseAmmo = false Auto

bool Property bAllowTeleportToInstitute = false Auto

Perk Property JBHuntingPerk Auto Const
Perk Property JBRenamePerk Auto Const
Perk Property JBTradePerk Auto Const

Keyword Property TeammateDontUseAmmoKeyword Auto Const

Keyword Property ActorTypeNPC Auto Const

Keyword Property ActorTypeHuman Auto Const

LocationRefType Property CustomBossLocRefType Auto Const

Container Property specialVendorContainerBase auto const
{ base object of special vendor container to link to when special ability is allowed }

Faction property WorkshopNPCFaction auto const mandatory
;Faction property PotentialCompanionFaction auto const mandatory
Faction property REFarmerFaction auto const mandatory

ActorValue property Assistance auto mandatory
ActorValue property Morality auto mandatory

Armor Property Collar Auto Const

Furniture Property PowerArmorFrameFurnitureNoCore Auto Const

Faction property DLC02WorkshopArenaCombatantFaction auto const mandatory
Faction property DLC02WorkshopArenaCombatantEnemyFaction auto const mandatory

ActorValue property DLC02WorkshopWork24HoursFlag auto const mandatory
{ stores original value of JBbWork24Hours }

ActorValue property DLC02WorkshopRatingArenaPlatform auto const mandatory
{ use to get all arena platforms in current workshop }

Furniture Property DLC02WorkshopArenaCombatantA Auto Const
Furniture Property DLC02WorkshopArenaCombatantB Auto Const

Faction property DLC06WorkshopVendorFactionBarber auto const mandatory
Faction property DLC06WorkshopVendorFactionSurgery auto const mandatory

Furniture Property DLC06WorkshopBarberChair Auto Const
Furniture Property DLC06WorkshopSurgeryChair Auto Const

Idle Property ElevatorFaceCamera Auto
Idle Property ElevatorBodyCamera Auto

ReferenceAlias Property editableSlave Auto Const

ReferenceAlias Property Companion Auto Const

ReferenceAlias Property SlaveForSexA Auto Const
ReferenceAlias Property SlaveForSexB Auto Const

ReferenceAlias Property SlaveProstitute Auto Const
ReferenceAlias Property clientForProstitute Auto Const

ReferenceAlias Property Product Auto Const

Scene Property JBProstituteCustomerYesScene01 Auto Const
Scene Property JBProstituteCustomerNoScene01 Auto Const

Holotape Property JBSCSHolotape Auto Const

Float Property sexDuration = 30.0 Auto

Bool Property allowEscape = true Auto

Bool Property allowManageVassal = false Auto

Float Property prostituteSearchCustomerRadius = 500.0 Auto
Float Property prostituteSearchCustomerInterval = 120.0 Auto

Int Property preventFurniture = 0 Auto
{
	0 - none
	1 - prevent
	2 - ask
}

Int Property usePackages = 0 Auto
{
	0 - use
	1 - not use
	2 - ask
}

bool Property availableForSale = false Auto Conditional

bool Property followerInCommandMode = false Auto Conditional

; timer IDs
;int dailyUpdateTimerID = 0 const
int slaveStatsTimerID = 0 const

; update timer
float updateIntervalGameHours = 24.0 const	 ; daily
float dailyUpdateSpreadHours = 12.0 const  	; how many hours to spread out (total) all the daily updates for workshops
float updateSlaveStatsInterval = 1.0 const

bool EditLock = false

float startingHappiness = 50.0 const					; happiness of a new workshop starts here
float startingHappinessMin = 20.0 const 

float actorDeathHappinessModifier = -20.0 const

int ArenaCombatantDeathHappinessPenalty = -5 const

Faction[] JBcombatantFactionType

;AAF:AAF_API AAF_API

four_play:Main FP_API


Event OnQuestInit()
	RegisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")
	RegisterCustomEvents()
	;LoadAAF()
	LoadFP()
	if (Game.GetPlayer().GetItemCount(JBSCSHolotape) == 0)
		Game.GetPlayer().AddItem(JBSCSHolotape)
	endIf
	previousModVersion = currentModVersion
EndEvent

;Event OnStageSet(int auiStageID, int auiItemID)
	;debug.OpenUserLog(userlogName)
;EndEvent


Event OnTimerGameTime(int aiTimerID)
;	Debug.Notification("OnTimerGameTime")
	if aiTimerID == slaveStatsTimerID
		UpdateSubmissive()
		; start timer again
		StartTimerGameTime(updateSlaveStatsInterval, slaveStatsTimerID)
	endif
EndEvent


;*********************************************************************************************************
;*********************************WorshopNPCScript functions rework***************************************
;*********************************************************************************************************
int function GetWorkshopID(Actor akSlave)
	int workshopID = akSlave.GetValue(WorkshopParent.workshopIDActorValue) as int
	return workshopID
endFunction


function SetWorkshopID(Actor theActor, int newWorkshopID)
	int workshopID = newWorkshopID
	theActor.SetValue(WorkshopParent.workshopIDActorValue, newWorkshopID)
	; put script in correct state (we only care about events if assigned to a workshop)
	if newWorkshopID > -1
		SetWorkshopStatus(theActor, true)
		;SetCommandable(theActor, true)
		;SetAllowCaravan(theActor, true)
		;SetAllowMove(theActor, true)
;		gotoState("assigned")
	else
		SetWorkshopStatus(theActor, false)
;		gotoState("unassigned")
	endif
endFunction


function UpdatePlayerOwnership(Actor theActor, WorkshopScript workshopRef = NONE)
	; get workshop if not passed in
	if workshopRef == NONE
		workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(theActor))
	endif

	;jbTrace("	" + theActor + " UpdatePlayerOwnership for workshop " + workshopRef + ": OwnedByPlayer=" + workshopRef.OwnedByPlayer)
	if workshopRef
		; set player ownership actor value
		theActor.SetValue(WorkshopParent.WorkshopPlayerOwnership, workshopRef.OwnedByPlayer as int)
	endif
endFunction


int function GetCaravanDestinationID(Actor akSlave)
	return akSlave.GetValue(WorkshopParent.WorkshopCaravanDestination) as int   
endFunction


bool function IsWounded(Actor akSlave)
	return akSlave.GetValue(WorkshopParent.WorkshopActorWounded) as bool
endFunction


function SetWounded(Actor akSlave, bool bIsWounded)
	akSlave.SetValue(WorkshopParent.WorkshopActorWounded, bIsWounded as int)
	; am I a caravan actor?
	int foundIndex = WorkshopParent.CaravanActorAliases.Find(akSlave)
	if foundIndex > -1
		TurnOnCaravanSlave(akSlave, bIsWounded == false)
	endif
endFunction


function SetWorker(Actor akSlave, bool isWorker)
	if isWorker
		akSlave.SetValue(JBbIsWorker, 1)
	else
		akSlave.SetValue(JBbIsWorker, 0)
		akSlave.SetValue(JBIsWorkStatus, 0)
	endif
endFunction


function SetScavenger(Actor akSlave, bool isScavenger)
	if isScavenger
		akSlave.SetValue(JBIsWorkStatus, 2)
	else
		akSlave.SetValue(JBIsWorkStatus, 0)
	endif
endFunction


function SetMultiResource(Actor theActor, ActorValue resourceValue)
	;jbTrace("	" + theActor + " SetMultiResource: resourceValue=" + resourceValue)

	theActor.SetValue(JBassignedMultiResource, WorkshopParent.GetResourceIndex(resourceValue))
	if WorkshopParent.WorkshopRatings[theActor.GetValue(JBassignedMultiResource) as int].resourceValue == WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingSafety].resourceValue
		theActor.SetValue(JBIsWorkStatus, 1)
	else
		theActor.SetValue(JBIsWorkStatus, 0)
	endif

	if !WorkshopParent.WorkshopRatings[theActor.GetValue(JBassignedMultiResource) as int].resourceValue
		; clear production if no longer assigned to a multiresource
		theActor.SetValue(JBmultiResourceProduction, 0.0)
	endif
endFunction


function AddMultiResourceProduction(Actor theActor, float newProduction)
	float newResourceProduction = theActor.GetValue(JBmultiResourceProduction)
	newResourceProduction += newProduction
	theActor.SetValue(JBmultiResourceProduction, newResourceProduction)
endFunction


function SetAsBoss(Actor theActor, Location newLocation)
	if CustomBossLocRefType
		theActor.SetLocRefType(newLocation, CustomBossLocRefType)
	else
		theActor.SetLocRefType(newLocation, WorkshopParent.Boss)
	endif
	theActor.ClearFromOldLocations() ; 101931: make sure location data is correct
endFunction


int timerIDCommandState = 1
float timerCommandStateSeconds = 5.0

int timerIDAssigned = 2 			; run a timer when assigned to a new work object
float timerAssignedSeconds = 120.0 ; how long to stay in the "just assigned" package

function StartAssignmentTimer(Actor theActor, bool bStart = true)
	if bStart
		; set assigned actor value
		theActor.SetValue(WorkshopParent.WorkshopActorAssigned, 1)
		theActor.StartTimer(timerAssignedSeconds, timerIDAssigned)
		theActor.EvaluatePackage()
	else
		; clear assigned actor value
		theActor.SetValue(WorkshopParent.WorkshopActorAssigned, 0)
		theActor.CancelTimer(timerIDAssigned)
	endif
endFunction


function StartCommandState(Actor akSlave)
	; clear "activate count"
	int iSelfActivationCount = 0
	; set up distance check from workshop
	WorkshopScript myWorkshop = WorkshopParent.GetWorkshop(GetWorkshopID(akSlave))
	if myWorkshop
		StartTimer(timerCommandStateSeconds, timerIDCommandState)
		akSlave.setDoingFavor(abDoingFavor = true, abWorkShopMode = true)
	endif
endFunction


function SetCommandable(Actor akSlave, bool bFlag)
	if bFlag
		akSlave.AddKeyword(WorkshopParent.WorkshopAllowCommand)
	else
		akSlave.RemoveKeyword(WorkshopParent.WorkshopAllowCommand)
	endif
endFunction


function SetAllowCaravan(Actor akSlave, bool bFlag)
	if bFlag
		akSlave.AddKeyword(WorkshopParent.WorkshopAllowCaravan)
	else
		akSlave.RemoveKeyword(WorkshopParent.WorkshopAllowCaravan)
	endif
endFunction


function SetAllowMove(Actor akSlave, bool bFlag)
	if bFlag
		akSlave.AddKeyword(WorkshopParent.WorkshopAllowMove)
	else
		akSlave.RemoveKeyword(WorkshopParent.WorkshopAllowMove)
	endif
endFunction


function SetWorkshopStatus(Actor akSlave, bool setWorkshopStatusOn)
	if setWorkshopStatusOn
		SetCommandable(akSlave, true)
		SetAllowMove(akSlave, true)
		SetAllowCaravan(akSlave, true)
	else
		SetCommandable(akSlave, false)
		SetAllowMove(akSlave, false)
		SetAllowCaravan(akSlave, false)
		;UnassignSlave(akSlave)
	endif
endFunction


;*********************************************************************************************************
;********************************WorshopObjectScript functions rework*************************************
;*********************************************************************************************************
bool function IsActorAssigned(WorkshopObjectScript theObject)
	bool val = GetAssignedActor(theObject) != NONE
	if !val && theObject.IsBed() && theObject.GetFactionOwner() != NONE
		; if I'm a bed, faction ownership counts as valid "assignment"
		;jbTrace("	" + theObject + " IsActorAssigned - bed with faction ownership = true")
		val = true
	endif
	;jbTrace("	" + theObject + " IsActorAssigned=" + val )
	return val
endFunction


Actor function GetAssignedActor(WorkshopObjectScript theObject)
	;jbTrace("	GetAssignedActor for " + theObject)
	Actor assignedActor = theObject.GetActorRefOwner() as Actor
	if !assignedActor
		; check for base actor ownership
		ActorBase baseActor = theObject.GetActorOwner()
		;jbTrace("	GetAssignedActor: baseActor=" + baseActor)
		if baseActor && baseActor.IsUnique()
			; if this has Actor ownership, use GetUniqueActor when available to get the actor ref
			assignedActor = baseActor.GetUniqueActor() as Actor
		endif
	endif
;	jbTrace("	GetAssignedActor: " + assignedActor)
;	return assignedActor
	if assignedActor == Game.GetPlayer()
		;jbTrace("	GetAssignedActor: NONE")
		return NONE
	Else
		;jbTrace("	GetAssignedActor: " + assignedActor)
		return assignedActor
	endif
endFunction


bool function IsFactionOwner(WorkshopObjectScript theObject, Actor theActor)
	Faction theFaction = theObject.GetFactionOwner()
	return ( theFaction && theActor.IsInFaction(theFaction) )
endFunction


function AssignSlave(WorkshopObjectScript workObject, Actor newActor = None)
	;jbTrace("	AssignSlave " + workObject + "	AssignSlave: newActor=" + newActor)

	if newActor
		; if this is a bed, and has faction ownership OR actor base ownership, just keep it
		if workObject.IsBed() && ( workObject.IsOwnedBy(newActor) )
			; do nothing - editor-set faction ownership for double beds etc.
		else
			workObject.SetActorRefOwner(newActor, true)
		endif

		workObject.SetLinkedRef(newActor, JBSlaveWorkObject)

		; add/remove special combat faction
		; also protected status
		if workObject.HasResourceValue(DLC02WorkshopRatingArenaPlatform)
			JBcombatantFactionType = GetCombatantFactions(workObject)
			AssignArenaCombatant(workObject, newActor, true)
			RegisterForRemoteEvent(newActor, "OnDying")
			; if a companion, send assault alarm against enemy team

			;if newActor.IsInFaction(HasBeenCompanionFaction) || newActor.GetHighestRelationshipRank() > 0
			if JBSlaveCollection.Find(newActor) > -1	
				;debug.trace(self + " AssignActor: " + newActor + " is companion or family NPC - find enemy combatants")
				WorkshopScript workshopRef = WorkshopParent.GetWorkshop(workObject.workshopID)
				ObjectReference[] arenaPlatforms = WorkshopParent.GetResourceObjects(workshopRef, DLC02WorkshopRatingArenaPlatform)
				; find actors in the enemy arena faction
				int i = 0
				while i < arenaPlatforms.Length
					ObjectReference thePlatform = arenaPlatforms[i]
					;if thePlatform && thePlatform.GetBaseObject() != self.GetBaseObject() && thePlatform.HasActorRefOwner()
					if thePlatform && thePlatform.GetBaseObject() != workObject.GetBaseObject() && thePlatform.HasActorRefOwner()
						; get owner and see if enemy
						Actor theNPC = thePlatform.GetActorRefOwner()
						if theNPC && theNPC.IsInFaction(JBcombatantFactionType[1])
							theNPC.StartCombat(newActor)
							newActor.StartCombat(theNPC)
						endif
					endif
					i += 1
				endWhile
			endif
		endif

		If workObject.GetBaseObject() == DLC06WorkshopBarberChair as Form
			AssignBarberVendor(workObject, newActor, true)
		EndIf

		If workObject.GetBaseObject() == DLC06WorkshopSurgeryChair as Form
			AssignSurgeryVendor(workObject, newActor, true)
		EndIf
		
		workObject.AssignActorOwnership(newActor)

		; link actor to me if keyword
		if workObject.AssignedActorLinkKeyword
			newActor.SetLinkedRef(workObject, workObject.AssignedActorLinkKeyword)
		endif
	else

		If workObject.HasResourceValue(DLC02WorkshopRatingArenaPlatform)
			Actor oldActor = workObject.GetActorRefOwner()
			if oldActor
				AssignArenaCombatant(workObject, oldActor, false)
				UnregisterForRemoteEvent(oldActor, "OnDying")
			endif
		EndIf

		If workObject.GetBaseObject() == DLC06WorkshopBarberChair as Form
			Actor oldActor = workObject.GetActorRefOwner()
			AssignBarberVendor(workObject, oldActor, false)
		EndIf

		If workObject.GetBaseObject() == DLC06WorkshopSurgeryChair as Form
			Actor oldActor = workObject.GetActorRefOwner()
			AssignSurgeryVendor(workObject, oldActor, false)
		EndIf

		workObject.SetLinkedRef(None, JBSlaveWorkObject)
	
		workObject.AssignActorOwnership(none)
	
;		workObject.SetActorRefOwner(none)
		; default ownership = player (so enemies will attack them if appropriate)
		workObject.SetActorOwner(Game.GetPlayer().GetActorBase())
;		jbTrace("	AssignSlave " + workObject + " AssignSlave: no owner, so assigning player ownership: " + workObject.GetActorOwner())
	endif

;	AssignActorCustom(newActor)
endFunction


function AssignArenaCombatant(WorkshopObjectScript workObject, Actor assignedActor, bool bAssignToArena)
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(workObject.workshopID)
	JBcombatantFactionType = GetCombatantFactions(workObject)

	if bAssignToArena
		assignedActor.SetValue(JBIsWorkStatus, 1) ; weapon out
		assignedActor.AddToFaction(JBcombatantFactionType[0])
		assignedActor.RemoveFromFaction(WorkshopNPCFaction)
		assignedActor.RemoveFromFaction(REFarmerFaction)

		assignedActor.SetValue(DLC02WorkshopWork24HoursFlag, assignedActor.GetValue(JBbWork24Hours))
		assignedActor.SetValue(JBbWork24Hours, 1)

		if JBSlaveCollection.Find(assignedActor) > -1
			assignedActor.SetProtected(false)
		endif
	else
		assignedActor.SetValue(JBIsWorkStatus, 0) ; clear weapon out package
		assignedActor.RemoveFromFaction(JBcombatantFactionType[0])
		assignedActor.AddToFaction(WorkshopNPCFaction)

		; clear combat alarms in case already fighting other arena combatants
		assignedActor.StopCombatAlarm()

		; restore original value for this flag
		assignedActor.SetValue(JBbWork24Hours, assignedActor.GetValue(DLC02WorkshopWork24HoursFlag))

		if JBSlaveCollection.Find(assignedActor) > -1
			assignedActor.SetProtected(true)
		endif
	endif

	if workshopRef.SettlementOwnershipFaction && workshopRef.UseOwnershipFaction; && assignedActor.bApplyWorkshopOwnerFaction
			if bAssignToArena
				assignedActor.RemoveFromFaction(workshopRef.SettlementOwnershipFaction)
			else
				assignedActor.SetCrimeFaction(workshopRef.SettlementOwnershipFaction)
			endif
		;else
			;if bAssignToArena
				;assignedActor.SetFactionOwner(NONE)
			;else
				;assignedActor.SetFactionOwner(workshopRef.SettlementOwnershipFaction)
			;endif
		;endif
	endif

endFunction

function AssignBarberVendor(WorkshopObjectScript workObject, Actor assignedActor, bool bAssign)
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(workObject.workshopID)

	if bAssign
		assignedActor.AddToFaction(DLC06WorkshopVendorFactionBarber)
	else
		assignedActor.RemoveFromFaction(DLC06WorkshopVendorFactionBarber)
	endif
	DLC06:WorkshopBarberChairScript barberChair = workObject as DLC06:WorkshopBarberChairScript
	barberChair.ResetBarberChair()
endFunction

function AssignSurgeryVendor(WorkshopObjectScript workObject, Actor assignedActor, bool bAssign)
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(workObject.workshopID)

	if bAssign
		assignedActor.AddToFaction(DLC06WorkshopVendorFactionSurgery)
	else
		assignedActor.RemoveFromFaction(DLC06WorkshopVendorFactionSurgery)
	endif
	DLC06:WorkshopSurgeryChairScript surgeryChair = workObject as DLC06:WorkshopSurgeryChairScript
	surgeryChair.ResetSurgeryGurney()
endFunction

Function ActivatedByWorkshopSlave(WorkshopObjectScript workObject, Actor workshopNPC)
	if workshopNPC; && workshopNPC.IsDoingFavor() && workshopNPC.IsInFaction(WorkshopParent.Followers.CurrentCompanionFaction) == false
		;jbTrace("	ActivatedByWorkshopSlave " + workObject + " activated by " + workshopNPC)
		if workObject.bAllowPlayerAssignment
			; turn off favor state
			workshopNPC.setDoingFavor(false, false) ; going back to using normal command mode for now
			; unregister for distance event
			workshopNPC.UnregisterForDistanceEvents(workshopNPC, WorkshopParent.GetWorkshop(workObject.workshopID))
			; assign this NPC to me if this is a work object
			if workObject.RequiresActor() || workObject.IsBed()
				workshopNPC.SayCustom(WorkshopParent.WorkshopParentAssignConfirmTopicType)
				AssignSlaveToObjectPUBLIC(workshopNPC, workObject)
				WorkshopParent.WorkshopResourceAssignedMessage.Show()
				StartAssignmentTimer(workshopNPC)
				; if food/water/safety are missing, run check if this is that kind of object
				if workObject.IsBed() == false
					WorkshopScript workshopRef = WorkshopParent.GetWorkshop(workObject.workshopID)
					workshopRef.RecalculateResources()
				endif

			endif
			workshopNPC.EvaluatePackage()
		else
			WorkshopParent.WorkshopResourceNoAssignmentMessage.Show()
		endif
	endif

EndFunction


;*********************************************************************************************************
;********************************WorshopParentScript functions rework*************************************
;*********************************************************************************************************
function WoundSlave(Actor woundedActor, bool bWoundMe = true)

	; get actor's workshop
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(woundedActor))
	; wound/heal actor
	SetWounded(woundedActor, bWoundMe)

	; increase or decrease damage?
	int damageValue = 1
	if !bWoundMe
		damageValue = -1
	endif

	; update damage rating
	; RESOURCE CHANGE:
	; reduce extra pop damage if > 0 ; otherwise, damage is normally tracked within WorkshopRatingPopulation (difference between base value and current value)
	if bWoundMe == false && workshopRef.GetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingDamagePopulation].resourceValue) > 0
		WorkshopParent.ModifyResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingDamagePopulation].resourceValue, workshopRef, damageValue)
	endif

	; update my work objects for "can produce"
	UpdateSlavesWorkObjects(woundedActor, workshopRef, true)

endFunction

function HandleSlaveDeath(Actor deadActor)
	; get actor's workshop
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(deadActor))
	
	int sInd = JBSlaveCollection.Find(deadActor)

	UnassignSlave(deadActor, true)
	; consequences of death:
	; for people, count this as negative to happiness (blame player since they're all protected)
	if JBbCountsForPopulation.GetValueInt() == 1
		WorkshopParent.ModifyHappinessModifier(workshopRef, actorDeathHappinessModifier)
	endif
endFunction


function UpdateSlavesWorkObjects(Actor theActor, WorkshopScript workshopRef = NONE, bool bRecalculateResources = false)
	if workshopRef == NONE
		workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(theActor))
	endif

	; find my assigned object, if any
	; loop through work objects list, looking for things assigned to me - then update stats for each
	int i = 0
	ObjectReference[] ResourceObjects = workshopRef.GetWorkshopOwnedObjects(theActor)
	while i < ResourceObjects.Length
		WorkshopObjectScript theObject = ResourceObjects[i] as WorkshopObjectScript

		; update rating for this object - don't recalc for each object to save time
		if theObject
			WorkshopParent.UpdateWorkshopRatingsForResourceObject(theObject, workshopRef, bRecalculateResources = bRecalculateResources)
		endif
		i += 1
	endWhile
endFunction


function AssignSlaveToObjectPUBLIC(Actor assignedActor, WorkshopObjectScript assignedObject, bool bResetMode = false)
	;jbTrace("------------------------------------------------------------------------------ ")
	;jbTrace("	AssignSlaveToObjectPUBLIC actor=" + assignedActor + ", object=" + assignedObject)
	; lock editing
	GetEditLock()

	AssignSlaveToObject(assignedActor, assignedObject, bResetMode = bResetMode)

	EditLock = false
endFunction


function AssignSlaveToObject(Actor assignedActor, WorkshopObjectScript assignedObject, bool bResetMode = false, bool bAddActorCheck = true)
	;jbTrace("	AssignSlaveToObject actor=" + assignedActor + ", object=" + assignedObject + ", resetMode=" + bResetMode)

	WorkshopScript workshopRef
	if assignedObject.workshopID > -1
		workshopRef = WorkshopParent.GetWorkshop(assignedObject.workshopID)
	endif
	if workshopRef == NONE
		return
	endif

	; make sure I'm added to this workshop
	if bAddActorCheck
		AddSlaveToWorkshop(assignedActor, workshopRef, bResetMode)
	endif

	; get object's current owner
;	WorkshopNPCScript previousOwner = assignedObject.GetAssignedActor()
;	jbTrace("	AssignSlaveToObject: previousOwner actor=" + previousOwner)
	Actor previousSlaveOwner = GetAssignedActor(assignedObject)
	;jbTrace("	AssignSlaveToObject: previousSlaveOwner actor=" + previousSlaveOwner)

	; is this a bed or work object?
	if assignedObject.IsBed()
		; bed
		; find bed that was assigned to this actor and clear ownership
		ObjectReference[] WorkshopBeds = WorkshopParent.GetBeds(workshopRef)
		int i = 0
		while i < WorkshopBeds.Length
			WorkshopObjectScript theBed = WorkshopBeds[i] as WorkshopObjectScript
			if theBed && theBed.GetActorRefOwner() == assignedActor
				AssignSlave(theBed, NONE)
			endif
			i += 1
		endWhile

		; mark assigned object as assigned to this actor
		AssignSlave(assignedObject, assignedActor)
	elseif assignedObject.HasKeyword(WorkshopParent.WorkshopWorkObject)
		; work object
		; actor no longer counts as "new"
;		assignedActor.bNewSettler = false

		; is object already assigned to this actor?
;		bool bAlreadyAssigned = (previousOwner == assignedActor)
		bool bAlreadyAssigned = (previousSlaveOwner == assignedActor)
		;jbTrace("	AssignSlaveToObject: bAlreadyAssigned=" + bAlreadyAssigned)
		; unassign actor from whatever he was doing
;		actorValue multiResourceValue = assignedActor.assignedMultiResource
		actorValue multiResourceValue = WorkshopParent.GetRatingAV(assignedActor.GetValue(JBassignedMultiResource) as int)
		; if assigned actor is assigned to multi-resource, AND this has that resource, don't unassign him - can work on multiple resource objects
		;jbTrace("	AssignSlaveToObject: JBassignedMultiResource=" + multiResourceValue + ", assignedObject.HasResourceValue=" + assignedObject.HasResourceValue(multiResourceValue))
		bool bShouldUnassign = true
		if (multiResourceValue && assignedObject.HasResourceValue(multiResourceValue))
			; same multi resource - may not need to unassign if actor has enough unused resource points left
;			float totalProduction = assignedActor.multiResourceProduction + assignedObject.GetResourceRating(multiResourceValue)
			float totalProduction = assignedActor.GetValue(JBmultiResourceProduction) + assignedObject.GetResourceRating(multiResourceValue)
			int resourceIndex = WorkshopParent.GetResourceIndex(multiResourceValue)
			;jbTrace("	AssignSlaveToObject: totalProduction (with new object)=" + totalProduction + ", allowed max production=" + WorkshopParent.WorkshopRatings[resourceIndex].maxProductionPerNPC)
			if totalProduction <= WorkshopParent.WorkshopRatings[resourceIndex].maxProductionPerNPC
				bShouldUnassign = false
				; don't unassign - can work on multiple resource objects
				;jbTrace("	AssignSlaveToObject: actor already assigned to this resource type - don't unassign")
			else
				;jbTrace("	AssignSlaveToObject: actor will exceed max production for this resource type - DO unassign")
			endif
		elseif bAlreadyAssigned
			; already assigned
			;jbTrace("	AssignSlaveToObject: actor already assigned to this object - don't unassign")
			bShouldUnassign = false
		endif

		if bShouldUnassign
			;jbTrace("	AssignSlaveToObject: bShouldUnassign = true: unassigning " + assignedActor + " from previous work object")
			; unassign actor from previous work object
			UnassignSlave(assignedActor, bSendUnassignEvent = !bAlreadyAssigned)
		endif

		; unassign current owner, if any (and different from new owner)
		if previousSlaveOwner && previousSlaveOwner != assignedActor
			;jbTrace("	AssignSlaveToObject: unassign previous owner " + previousSlaveOwner)
			If JBSlaveCollection.Find(previousSlaveOwner) < 0
				WorkShopNPCScript previousOwner = previousSlaveOwner as WorkShopNPCScript
				WorkshopParent.UnassignActorFromObject(previousOwner, assignedObject)
			Else
				UnassignSlaveFromObject(previousSlaveOwner, assignedObject)
			EndIf
			;UnassignSlaveFromObject(previousSlaveOwner, assignedObject)
		endif

		; mark assigned object as assigned to this actor
		AssignSlave(assignedObject, assignedActor)

		; flag actor as a worker
		SetWorker(assignedActor, true)

		; 1.5 - new 24-hour work flag
		if assignedObject.bWork24Hours
;			assignedActor.bWork24Hours = true
			assignedActor.SetValue(JBbWork24Hours, 1)
		endif

		; if assigned object has scavenge rating, flag worker as scavenger (for packages)
		if assignedObject.HasResourceValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingScavengeGeneral].resourceValue)
			SetScavenger(assignedActor, true)
		endif

		; add vendor faction if any
		if assignedObject.VendorType > -1
			SetVendorData(workshopRef, assignedActor, assignedObject)
		endif

		;If assignedObject.HasKeyword(DLC05AnimFurnPillory)
		If JBRestrictList.HasForm(assignedObject.GetBaseObject())
			;Debug.Notification("JBSlaveRestricted - Add")
			assignedActor.AddKeyword(JBSlaveRestricted)
			JBSlaveRestrictedMSG.Show()
		EndIf

		; update workshop ratings for new assignment
		WorkshopParent.UpdateWorkshopRatingsForResourceObject(assignedObject, workshopRef)

		; remove "unassigned" resource value
		assignedActor.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulationUnassigned].resourceValue, 0)

		; to save time, in reset mode we ignore this and do it at the end
		if !bResetMode
			; reset unassigned population count
			WorkshopParent.SetUnassignedPopulationRating(workshopRef)
		endif

		; special cases:
		; is this a multi-resource object?
		if assignedObject.HasMultiResource()
			multiResourceValue = assignedObject.GetMultiResourceValue()
			; flag actor with this keyword
			SetMultiResource(assignedActor, multiResourceValue)
			AddMultiResourceProduction(assignedActor, assignedObject.GetResourceRating(multiResourceValue))
			if !bResetMode
				TryToAssignResourceType(workshopRef, multiResourceValue)				
			endif
		endif

		; reset ai to get him to notice the new markers
		assignedActor.EvaluatePackage()

	;jbTrace("	AssignActorToObject actor=" + assignedActor + ", object=" + assignedObject + ", resetMode=" + bResetMode + " DONE: bAlreadyAssigned=" + bAlreadyAssigned)

		; send custom event for this object
		; don't send event in reset mode, or if already assigned to this actor
		if bAlreadyAssigned == false
			Var[] kargs = new Var[2]
			kargs[0] = assignedObject
			kargs[1] = workshopRef
			;jbTrace(" 	sending WorkshopActorAssignedToWork event")
			WorkshopParent.SendCustomEvent("WorkshopActorAssignedToWork", kargs)		
		endif
	endif
endFunction


;function SetUnassignedPopulationRating(WorkshopScript workshopRef)
;	ObjectReference[] WorkshopActors = GetWorkshopActors(workshopRef)
	; count how many are unassigned
;	int unassignedPopulation = 0
;	int i = 0
;	while i < WorkshopActors.Length
;		WorkshopNPCScript theActor = WorkshopActors[i] as WorkShopNPCScript
;		if theActor && theActor.bIsWorker == false
;			unassignedPopulation += 1
;		endif
;		i += 1
;	endWhile

;	SetResourceData(WorkshopRatings[WorkshopRatingPopulationUnassigned].resourceValue, workshopRef, unassignedPopulation)
;endFunction

; utility function for setting/clearing vendor data on an actor
function SetVendorData(WorkshopScript workshopRef, Actor assignedActor, WorkshopObjectScript assignedObject, bool bSetData = true)

	if assignedObject.VendorType > -1
		WorkshopVendorType vendorData = WorkshopParent.WorkshopVendorTypes[assignedObject.VendorType]
		if vendorData
			; -- vendor faction
			if bSetData
				assignedActor.AddToFaction(vendorData.VendorFaction)
				if vendorData.keywordToAdd01
					assignedActor.AddKeyword(vendorData.keywordToAdd01)
				endif
			else
				assignedActor.RemoveFromFaction(vendorData.VendorFaction)
				if vendorData.keywordToAdd01
					assignedActor.RemoveKeyword(vendorData.keywordToAdd01)
				endif
			endif

			; -- assign vendor chests
			ObjectReference[] vendorContainers = workshopRef.GetVendorContainersByType(assignedObject.VendorType)
			int i = 0
			while i <= assignedObject.vendorLevel
				if bSetData
					;assignedActor.SetLinkedRef(vendorContainers[i], VendorContainerKeywords.GetAt(i) as Keyword)
					assignedActor.SetLinkedRef(vendorContainers[i], WorkshopParent.VendorContainerKeywords.GetAt(i) as Keyword)
				else
					;assignedActor.SetLinkedRef(NONE, VendorContainerKeywords.GetAt(i) as Keyword)
					assignedActor.SetLinkedRef(NONE, WorkshopParent.VendorContainerKeywords.GetAt(i) as Keyword)
				endif
				i += 1
			endWhile

			If bSetData
				assignedActor.SetValue(JBslaveVendorType, assignedObject.VendorType)
			Else
				assignedActor.SetValue(JBslaveVendorType, -1)
			EndIf

			; special vendor data
			ObjectReference specialVendorContainerRef
			if bSetData
				If (assignedActor.GetValue(JBslaveVendorType) as int) > -1 && (assignedActor.GetValue(JBslaveVendorType) as int) == assignedObject.VendorType
				;if assignedActor.specialVendorType > -1 && assignedActor.specialVendorType == assignedObject.VendorType
					; link to special vendor containers
					; if assignedActor.specialVendorContainerBase
					; 	; create the container ref if it doesn't exist yet
					; 	if assignedActor.specialVendorContainerRef == NONE
					; 		assignedActor.specialVendorContainerRef = WorkshopHoldingCellMarker.PlaceAtMe(assignedActor.specialVendorContainerBase)
					; 	endif
					; 	wsTrace("		special vendor matching this type: linking to " + assignedActor.specialVendorContainerRef + " with keyword " + VendorContainerKeywords.GetAt(VendorTopLevel+1) as Keyword)
					; 	; link using 4th keyword
					; 	assignedActor.SetLinkedRef(assignedActor.specialVendorContainerRef, VendorContainerKeywords.GetAt(VendorTopLevel+1) as Keyword)
					; endif
					; if assignedActor.specialVendorContainerRefUnique
					; 	wsTrace("		special vendor matching this type: linking to " + assignedActor.specialVendorContainerRefUnique + " with keyword " + VendorContainerKeywords.GetAt(VendorTopLevel+2) as Keyword)
					; 	; link using 4th keyword
					; 	assignedActor.SetLinkedRef(assignedActor.specialVendorContainerRefUnique, VendorContainerKeywords.GetAt(VendorTopLevel+2) as Keyword)
					; endif
					If assignedActor.GetLinkedRef(WorkshopParent.VendorContainerKeywords.GetAt(WorkshopParent.VendorTopLevel+1) as Keyword) == None
						specialVendorContainerRef = WorkshopParent.WorkshopHoldingCellMarker.PlaceAtMe(specialVendorContainerBase)
						assignedActor.SetLinkedRef(specialVendorContainerRef, WorkshopParent.VendorContainerKeywords.GetAt(WorkshopParent.VendorTopLevel+1) as Keyword)
					EndIf
				endif
			else
				; always clear for safety
				; if assignedActor.specialVendorContainerRef
				; 	assignedActor.specialVendorContainerRef.Delete()
				; 	assignedActor.specialVendorContainerRef = NONE
				; 	; clear link
				; 	assignedActor.SetLinkedRef(NONE, VendorContainerKeywords.GetAt(VendorTopLevel+1) as Keyword)
				; endif
				; if assignedActor.specialVendorContainerRefUnique
				; 	; clear link
				; 	assignedActor.SetLinkedRef(NONE, VendorContainerKeywords.GetAt(VendorTopLevel+2) as Keyword)
				; endif
				If assignedActor.GetLinkedRef(WorkshopParent.VendorContainerKeywords.GetAt(WorkshopParent.VendorTopLevel+1) as Keyword) != None
					specialVendorContainerRef = assignedActor.GetLinkedRef(WorkshopParent.VendorContainerKeywords.GetAt(WorkshopParent.VendorTopLevel+1) as Keyword)
					specialVendorContainerRef.Delete()
					assignedActor.SetLinkedRef(None, WorkshopParent.VendorContainerKeywords.GetAt(WorkshopParent.VendorTopLevel+1) as Keyword)
				EndIf

			endif

		else
			; ERROR
		endif
	endif

endFunction

function AssignCaravanSlavePUBLIC(Actor assignedActor, Location destinationLocation)
	; NOTE: package on alias uses two actor values to condition travel between the two workshops
	; lock editing
	GetEditLock()

	; get destination workshop
	WorkshopScript workshopDestination = WorkshopParent.GetWorkshopFromLocation(destinationLocation)

	; current workshop
	WorkshopScript workshopStart = WorkshopParent.GetWorkshop(GetWorkshopID(assignedActor))
	; unassign this actor from any current job
	UnassignSlave(assignedActor)

	; is this actor already assigned to a caravan?
	int caravanIndex = WorkshopParent.CaravanActorAliases.Find(assignedActor)
	if caravanIndex < 0
		; add to caravan actor alias collection
		WorkshopParent.CaravanActorAliases.AddRef(assignedActor)
		;if assignedActor.GetActorBase().IsUnique() == false && assignedActor.GetValue(WorkshopProhibitRename) == 0
;			wsTrace("		AssignCaravanActorPUBLIC actor=" + assignedActor + " not unique, putting in rename alias")
			; put in "rename" alias
			;CaravanActorRenameAliases.AddRef(assignedActor)
		;endif
	else
		; clear current location link
		Location oldDestination = WorkshopParent.GetWorkshop(GetCaravanDestinationID(assignedActor)).myLocation
		workshopStart.myLocation.RemoveLinkedLocation(oldDestination, WorkshopParent.WorkshopCaravanKeyword)
	endif

	If JBCaravanSlaveCollection.Find(assignedActor) < 0
		JBCaravanSlaveCollection.AddRef(assignedActor)
	EndIf
	
	int destinationID = workshopDestination.GetWorkshopID()

	; set destination actor value (used to find destination workshop from actor)
	assignedActor.SetValue(WorkshopParent.WorkshopCaravanDestination, destinationID)

	; make caravan ref type
	if assignedActor.IsCreated()
		assignedActor.SetLocRefType(workshopStart.myLocation, WorkshopParent.WorkshopCaravanRefType)
	endif

	; add linked refs to actor (for caravan package)
	assignedActor.SetLinkedRef(workshopStart.GetLinkedRef(WorkshopParent.WorkshopLinkCenter), WorkshopParent.WorkshopLinkCaravanStart)
	assignedActor.SetLinkedRef(workshopDestination.GetLinkedRef(WorkshopParent.WorkshopLinkCenter), WorkshopParent.WorkshopLinkCaravanEnd)

	; add link between locations
	workshopStart.myLocation.AddLinkedLocation(workshopDestination.myLocation, WorkshopParent.WorkshopCaravanKeyword)

	; 1.6: send custom event for this actor
	Var[] kargs = new Var[2]
	kargs[0] = assignedActor
	kargs[1] = workshopStart
	WorkshopParent.SendCustomEvent("WorkshopActorCaravanAssign", kargs)

	; stat update
	Game.IncrementStat("Supply Lines Created")

	; unlock editing
	EditLock = false
endFunction

; call this to temporarily turn on/off a caravan actor - remove brahmin and unlink
function TurnOnCaravanSlave(Actor caravanActor, bool bTurnOn, bool bBrahminCheck = true)
	; find linked locations
	WorkshopScript workshopStart = WorkshopParent.GetWorkshop(GetWorkshopID(caravanActor))

	Location startLocation = workshopStart.myLocation
	Location endLocation = WorkshopParent.GetWorkshop(GetCaravanDestinationID(caravanActor)).myLocation

	if bTurnOn
		; add link between locations
		startLocation.AddLinkedLocation(endLocation, WorkshopParent.WorkshopCaravanKeyword)
	else
		; unlink locations
		startLocation.RemoveLinkedLocation(endLocation, WorkshopParent.WorkshopCaravanKeyword)
	endif

	if bBrahminCheck
		CaravanSlaveBrahminCheck(caravanActor, bTurnOn)
	endif
endFunction

; check to see if this actor needs a new brahmin, or if current brahmin should be flagged for delete
function CaravanSlaveBrahminCheck(Actor actorToCheck, bool bShouldHaveBrahmin = true)

	; is my brahmin dead?
	if actorToCheck.GetLinkedRef(JBCaravanBrahmin) != None && (actorToCheck.GetLinkedRef(JBCaravanBrahmin) as Actor).IsDead()
		; clear
		WorkshopParent.CaravanBrahminAliases.RemoveRef(actorToCheck.GetLinkedRef(JBCaravanBrahmin))
		actorToCheck.SetLinkedRef(None, JBCaravanBrahmin)
	endif

	; should I have a brahmin?
	if WorkshopParent.CaravanActorAliases.Find(actorToCheck) > -1 && bShouldHaveBrahmin && IsWounded(actorToCheck) == false
		; if I don't have a brahmin, make me a new one
		if actorToCheck.GetLinkedRef(JBCaravanBrahmin) == None && IsWounded(actorToCheck) == false
			Actor myBrahmin = actorToCheck.placeAtMe(WorkshopParent.CaravanBrahmin) as Actor
			actorToCheck.SetLinkedRef(myBrahmin, JBCaravanBrahmin)
			myBrahmin.SetActorRefOwner(actorToCheck)
			WorkshopParent.CaravanBrahminAliases.AddRef(myBrahmin)
			myBrahmin.SetLinkedRef(actorToCheck, WorkshopParent.WorkshopLinkFollow)
		endif
	else
		; clear and delete brahmin
		if actorToCheck.GetLinkedRef(JBCaravanBrahmin) != None
			; clear this and mark brahmin for deletion
			Actor deleteBrahmin = actorToCheck.GetLinkedRef(JBCaravanBrahmin) as Actor
			WorkshopParent.CaravanBrahminAliases.RemoveRef(deleteBrahmin)
			actorToCheck.SetLinkedRef(None, JBCaravanBrahmin)
			deleteBrahmin.Delete()
			deleteBrahmin.SetLinkedRef(NONE, WorkshopParent.WorkshopLinkFollow)
		endif
	endif
endFunction

location function AddSlaveToWorkshopPlayerChoice(Actor actorToAssign = NONE, bool bWaitForActorToBeAdded = false, bool bPermanentActor = false)
;	if actorToAssign == NONE
;		actorToAssign = WorkshopParent.WorkshopRecruit.GetActorRef()
;	endif
	
	;jbTrace(" AddSlaveToWorkshopPlayerChoice " + actorToAssign, bNormalTraceAlso = true)
	; this only works on actors with the workshop script
;	WorkShopNPCScript workshopActorToAssign = actorToAssign as WorkShopNPCScript
;	if !workshopActorToAssign
;		wsTrace(" WARNING: AddActorToWorkshopPlayerChoice: invalid actor " + actorToAssign + " - NOT assigned", 2)
;		return None
;	endif

	keyword keywordToUse = WorkshopParent.WorkshopAssignHome
	if bPermanentActor
		keywordToUse = WorkshopParent.WorkshopAssignHomePermanentActor
	endif

	WorkshopScript previousWorkshop = WorkshopParent.GetWorkshop(GetWorkshopID(actorToAssign))
	Location previousLocation = NONE
	if previousWorkshop
		previousLocation = previousWorkshop.myLocation
	endif

	; 102314: allow non-population actors to be assigned to any workshop
	FormList excludeKeywordList
	if JBbCountsForPopulation.GetValueInt() == 1
		excludeKeywordList = WorkshopParent.WorkshopSettlementMenuExcludeList
	endif 
	Location newLocation = actorToAssign.OpenWorkshopSettlementMenuEx(akActionKW=keywordToUse, aLocToHighlight=previousLocation, akExcludeKeywordList=excludeKeywordList)

	if bWaitForActorToBeAdded && newLocation
		; wait for menu to resolve (when called in scenes)
		int failsafeCount = 0
		while failsafeCount < 5 && GetWorkshopID(actorToAssign) == -1
			failsafeCount += 1
			utility.wait(0.5)
		endWhile
	endif
	;jbTrace("AddSlaveToWorkshopPlayerChoice DONE")

	return newLocation	
endFunction


function AddSlaveToWorkshopPUBLIC(Actor assignedActor, WorkshopScript workshopRef, bool bResetMode = false)
	GetEditLock()

	AddSlaveToWorkshop(assignedActor, workshopRef, bResetMode)

	; unlock editing
	EditLock = false
endFunction


function AddSlaveToWorkshop(Actor assignedActor, WorkshopScript workshopRef, bool bResetMode = false, ObjectReference[] WorkshopActors = NONE)
	; bResetMode: true means to ignore TryToAssignFarms/Beds calls (ResetWorkshop calls it once at the end)
	; WorkshopActors: if NONE, get new list, otherwise use passed in list (to save time)
	
	;jbTrace("	AddSlaveToWorkshop actor=" + assignedActor + ", workshop=" + workshopRef + ", resetMode? " + bResetMode)
	
	bool bResetHappiness = false

	; if already in the list, do nothing
	if WorkshopActors == NONE
		WorkshopActors = GetWorkshopSlaves(workshopRef)
	endif

	bool bAlreadyAssigned = false
	if WorkshopActors.Find(assignedActor) > -1 && GetWorkshopID(assignedActor) == workshopRef.GetWorkshopID()
		;jbTrace("	AddSlaveToWorkshop actor=" + assignedActor + " already assigned to this workshop")
		bAlreadyAssigned = true
	endif

	; if actor is currently assigned to a different workshop, remove from that one
	int oldWorkshopID = GetWorkshopID(assignedActor)
	;jbTrace("	AddSlaveToWorkshop: oldWorkshopID=" + oldWorkshopID)
	if oldWorkshopID > -1 && oldWorkshopID != workshopRef.GetWorkshopID()
		; 89671: no need to remove actor from workshop completely when assigning to different workshop
		UnassignSlave(assignedActor, false)
		; clear "new settler" flag on actor
;		assignedActor.bNewSettler = false
	endif
	;jbTrace("	AddSlaveToWorkshop: step 2")

	if bAlreadyAssigned == false
		SetWorkshopID(assignedActor, workshopRef.GetWorkshopID())
		if workshopRef.SettlementOwnershipFaction && workshopRef.UseOwnershipFaction; && assignedActor.bApplyWorkshopOwnerFaction
;?			if assignedActor.bCountsForPopulation
;				assignedActor.SetCrimeFaction(workshopRef.SettlementOwnershipFaction)
;			else
;				assignedActor.SetFactionOwner(workshopRef.SettlementOwnershipFaction)
;			endif
		endif

		If assignedActor.IsPlayerTeammate()
			SetCommandMode(assignedActor, false)
		EndIf
		
		; add linked ref so workshop knows about me
		assignedActor.SetLinkedRef(workshopRef, WorkshopParent.WorkshopItemKeyword)

		; assign "home" linked ref (for packages)
		WorkshopParent.AssignHomeMarkerToActor(assignedActor, workshopRef)

		; "stamp" alias data so they keep it even after being in alias - allows them to initialize to correct package even if Reset hasn't finished running
;?		WorkshopParent.ApplyWorkshopAliasData(assignedActor)
		;jbTrace("	AddSlaveToWorkshop: step 3")

		; set player ownership actor value
		UpdatePlayerOwnership(assignedActor, workshopRef)
		
		; 98730: Recalc workshop ratings on old workshop (if there is one) now that actor is linked to new workshop
		if oldWorkshopID > -1 && oldWorkshopID != workshopRef.GetWorkshopID()
			WorkshopScript oldWorkshopRef = WorkshopParent.GetWorkshop(oldWorkshopID)		
			if oldWorkshopRef
				oldWorkshopRef.RecalculateWorkshopResources()
			endif 
		endif

		; if this was the first actor, this is the first actor - set happiness to "baseline" and modifiers to 0
;		if assignedActor.bCountsForPopulation
		if JBbCountsForPopulation.GetValueInt() == 1
			int totalPopulation = workshopRef.GetBaseValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue) as int
			float currentHappiness = workshopRef.GetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingHappiness].resourceValue)
			;jbTrace("	AddSlaveToWorkshop: step 4: totalPopulation=" + totalPopulation)
			if totalPopulation == 0
				; clear happiness modifier
				WorkshopParent.SetResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingHappinessModifier].resourceValue, workshopRef, 0)
				if bResetMode
					; just set happiness to baseline (nothing else we can do)
					WorkshopParent.SetResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingHappiness].resourceValue, workshopRef, startingHappiness)
					WorkshopParent.SetResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingHappinessTarget].resourceValue, workshopRef, startingHappiness)
				else
					; reset happiness to happiness target later (once everything is assigned)
					bResetHappiness = true
				endif
				; set "last attacked" to a very large number (so they don't act like they were just attacked)
				WorkshopParent.SetResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingLastAttackDaysSince].resourceValue, workshopRef, 99)
			endif
			; update workshop rating - increment unassigned actors resource value
			assignedActor.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulationUnassigned].resourceValue, 1)

			; update vendor data in all stores
			WorkshopParent.UpdateVendorFlagsAll(workshopRef)
		endif

		; assign persist location (if created)
		if assignedActor.IsCreated()
			assignedActor.SetPersistLoc(workshopRef.myLocation)
			; make Boss loc ref type for this location
;			if assignedActor.bIsSynth
;				wstrace(" 	" + assignedActor + " is a SYNTH - adding synth ref type")
;				assignedActor.SetLocRefType(workshopRef.myLocation, WorkshopSynthRefType)
;				wstrace(" 	" + assignedActor + " GetLocRefType = " + assignedActor.GetLocRefTypes())
;				assignedActor.ClearFromOldLocations() ; 101931: make sure location data is correct
;			elseif assignedActor.bCountsForPopulation
;				assignedActor.SetAsBoss(workshopRef.myLocation)
;			endif
			SetAsBoss(assignedActor, workshopRef.myLocation)
		endif

	endif

	; reset mode - called by ResetWorkshop (so usually these actors will already be assigned to the workshop)
	if bResetMode
		; clear multiresource production VALUE on reset - otherwise we keep adding to the total each time the actor is added during Reset process
		;jbTrace("	AddSlaveToWorkshop: clearing JBmultiResourceProduction")
;		assignedActor.multiResourceProduction = 0.0
		assignedActor.SetValue(JBmultiResourceProduction, 0.0)
	endif

	; clear actor worker flag
	if workshopRef.PlayerHasVisited && bAlreadyAssigned == false
		;jbTrace("	AddSlaveToWorkshop: clearing worker flag")
		SetWorker(assignedActor, false)
	endif

	; try to assign a bed
	;jbTrace("	AddSlaveToWorkshop: step 5 - try to assign a bed, maybe")

	if !bResetMode
;		TryToAssignBedToActor(workshopRef, assignedActor)
	endif

	; pick up new package if necessary
	assignedActor.EvaluatePackage()

;	if !workshopRef.RecalculateWorkshopResources()
	if !workshopRef.RecalculateWorkshopResources() && JBbCountsForPopulation.GetValueInt() == 1
		;jbTrace(" 	RecalculateWorkshopResources returned false - add population manually")
		; add population manually if couldn't recalc
		WorkshopParent.ModifyResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, workshopRef, 1)
	endif

	if !bResetMode && bResetHappiness
		WorkshopParent.ResetHappiness(workshopRef)
	endif

	;jbTrace("	AddSlaveToWorkshop: DONE")
endFunction


function UnassignSlaveFromObject(Actor theActor, WorkshopObjectScript theObject, bool bSendUnassignEvent = true)
	;jbTrace("	UnassignSlaveFromObject " + theActor + " from " + theObject)

	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(theActor))

	; do I currently own this object?
	if theObject.GetActorRefOwner() == theActor
		;jbTrace("		unassigning " + theObject)
		; this will also add the actor to the unassigned actor list (when it unassigns the last object)
		UnassignObject(theObject)
		if bSendUnassignEvent
			; send custom event for this object
			Var[] kargs = new Var[2]
			kargs[0] = theObject
			kargs[1] = workshopRef
			;jbTrace(" 	sending WorkshopActorUnassigned event")
			WorkshopParent.SendCustomEvent("WorkshopActorUnassigned", kargs)
		endif

		; do I still have any work objects?

		; work object?
;		ObjectReference[] WorkshopActors = WorkshopParent.GetWorkshopActors(workshopRef)
		ObjectReference[] WorkshopActors = GetWorkshopSlaves(workshopRef)
		int foundIndex = WorkshopActors.Find(theActor)
		if foundIndex > -1
			; unassign ownership of all work objects
			ObjectReference[] ResourceObjects = workshopRef.GetWorkshopOwnedObjects(theActor)
			if ResourceObjects.Length == 0
				; clear actor work flags
				SetMultiResource(theActor, NONE)
				SetWorker(theActor, false)
			endif
		endif
	endif
endFunction

function RemoveSlaveFromWorkshopPUBLIC(Actor theActor)
	; lock editing
	GetEditLock()

	UnassignSlave(theActor, true, true)

	; unlock editing
	EditLock = false
endFunction

function UnassignSlave(Actor theActor, bool bRemoveFromWorkshop = false, bool bSendUnassignEvent = true)
	;jbTrace("	UnassignSlave " + theActor + " bRemoveFromWorkshop=" + bRemoveFromWorkshop)

	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(theActor))

	; am I currently assigned to something?
	int foundIndex = -1

	; caravan?
	foundIndex = WorkshopParent.CaravanActorAliases.Find(theActor)
	if foundIndex > -1
		; remove me from the caravan alias collection
		WorkshopParent.CaravanActorAliases.RemoveRef(theActor)
		WorkshopParent.CaravanActorRenameAliases.RemoveRef(theActor)

		If JBCaravanSlaveCollection.Find(theActor) > -1
			JBCaravanSlaveCollection.RemoveRef(theActor)
		EndIf

		Location startLocation = workshopRef.myLocation
		Location endLocation = WorkshopParent.GetWorkshop(GetCaravanDestinationID(theActor)).myLocation
		; unlink locations
		startLocation.RemoveLinkedLocation(endLocation, WorkshopParent.WorkshopCaravanKeyword)

		; set back to Boss
		if theActor.IsCreated()
			; Patch 1.4: allow custom loc ref type on workshop NPC
			SetAsBoss(theActor, startLocation)
		endif

		; update workshop rating - increment unassigned actors total
		theActor.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulationUnassigned].resourceValue, 1)

		; clear caravan brahmin
		CaravanSlaveBrahminCheck(theActor)

		; 1.6: send custom event for this actor
		Var[] kargs = new Var[2]
		kargs[0] = theActor
		kargs[1] = workshopRef
		;jbTrace(" 	sending WorkshopActorCaravanUnassign event")
		WorkshopParent.SendCustomEvent("WorkshopActorCaravanUnassign", kargs)
	endif

	if GetWorkshopID(theActor) == workshopRef.GetWorkshopID()
		;jbTrace("	UnassignSlave: ActorWorkshopID - " + GetWorkshopID(theActor) + " , WorkshopID - " + workshopRef.GetWorkshopID() + " = " + GetWorkshopID(theActor) == workshopRef.GetWorkshopID())
		; unassign ownership of all work objects
		ObjectReference[] ResourceObjects = workshopRef.GetWorkshopOwnedObjects(theActor)
		;jbTrace("	UnassignSlave: " + theActor + " total object in owned: " + ResourceObjects.Length)
		int i = 0
		while i < ResourceObjects.Length
			; TEMP
			;jbTrace("	UnassignSlave: owned ref " + i + ": " + ResourceObjects[i])
			; end TEMP
			WorkshopObjectScript theObject = ResourceObjects[i] as WorkshopObjectScript
			jbTrace("	UnassignSlave: owned workshop object " + i + ": " + theObject)
			if theObject.RequiresActor() && theObject.GetActorRefOwner() == theActor; && theActor == GetAssignedActor(theObject) && theObject.IsOwnedBy(theActor)
				;jbTrace("	UnassignSlave: " + theObject + " Owner by "+ theActor + " = " + theObject.GetActorRefOwner() == theActor)
				;jbTrace("	UnassignSlave: unassigning " + theObject)
				; this will also add the actor to the unassigned actor list (when it unassigns the last object)
				UnassignObject(theObject)
				if bSendUnassignEvent
					; send custom event for this object
					Var[] kargs = new Var[2]
					kargs[0] = theObject
					kargs[1] = workshopRef
					;jbTrace(" 	sending WorkshopActorUnassigned event")
					WorkshopParent.SendCustomEvent("WorkshopActorUnassigned", kargs)
				endif
			endif
			i += 1
		endWhile

		; clear actor work flags
		SetMultiResource(theActor, NONE)
		SetWorker(theActor, false)
	else
;		jbTrace("		UnassignActor: NOTE - " + theActor + " is owned by workshop " + GetWorkshopID(theActor) + ", current workshop=" + currentWorkshopID + " - can't unassign ownership of work objects.")
	endif

	if bRemoveFromWorkshop
		;jbTrace("	UnassignActor " + theActor + ": removing from workshop")
		; completely remove from workshop

		; clear workshop linked ref
		theActor.SetLinkedRef(NONE, WorkshopParent.WorkshopItemKeyword)

		; clear applied alias data
		WorkshopParent.WorkshopActorApply.RemoveFromRef(theActor)

		; remove from permanent actor collection alias
		WorkshopParent.PermanentActorAliases.RemoveRef(theActor)
		
		; remove ownership flag to prevent trading
		theActor.SetValue(WorkshopParent.WorkshopPlayerOwnership, 0)	

		; PATCH - remove workshop ID as well
		SetWorkshopID(theActor, -1)

		; update population rating on workshop's location
;		if workshopRef.RecalculateWorkshopResources() == false
		if workshopRef.RecalculateWorkshopResources() == false && JBbCountsForPopulation.GetValueInt() == 1
			; decrement population manually if couldn't recalc
			WorkshopParent.ModifyResourceData(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, workshopRef, -1)
		endif
	endif

endFunction


function UnassignObject(WorkshopObjectScript theObject, bool bRemoveObject = false)
	; bRemoveObject = true  - means object is being completely removed from the workshop system
	;jbTrace("	UnassignObject " + theObject)
	if bRemoveObject
		;jbTrace("		REMOVING...")
	endif
	
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(theObject.workshopID)

	; get my owner (if any)
;	WorkshopNPCScript assignedActor = theObject.GetAssignedActor()
	
	Actor assignedSlave = GetAssignedActor(theObject)

	if assignedSlave
		; clear my ownership
		AssignSlave(theObject, none)

		; 1.5 - new 24-hour work flag
		if theObject.bWork24Hours
			assignedSlave.SetValue(JBbWork24Hours, 0)
		endif

		; clear link if it exists
		if theObject.AssignedActorLinkKeyword
			assignedSlave.SetLinkedRef(NONE, theObject.AssignedActorLinkKeyword)
		endif

		;  clear vendor faction from actor
		if theObject.VendorType > -1
			SetVendorData(workshopRef, assignedSlave, theObject, false)
		endif

		;If theObject.HasKeyword(DLC05AnimFurnPillory)
		If JBRestrictList.HasForm(theObject.GetBaseObject())
			;Debug.Notification("JBSlaveRestricted - Remove")
			assignedSlave.RemoveKeyword(JBSlaveRestricted)
		EndIf

		; is does my owner own anything else?
		ObjectReference[] ResourceObjects = workshopRef.GetWorkshopOwnedObjects(assignedSlave)
		int i = 0
		bool ownedObject = false
		while i < ResourceObjects.Length && ownedObject == false
			WorkshopObjectScript resourceObject = ResourceObjects[i] as WorkshopObjectScript
			if resourceObject && resourceObject.IsBed() == 0
				; exit loop
				ownedObject = true
			endif
			i += 1
		endWhile

		if ownedObject == false
			; this was the only thing I owned - add owner back to unassigned actor list
			assignedSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulationUnassigned].resourceValue, 1)
			SetMultiResource(assignedSlave, NONE)
			SetWorker(assignedSlave, false)
		endif
	endif

;	if assignedSlave || assignedActor || bRemoveObject
	if assignedSlave || bRemoveObject
		; update ratings
		WorkshopParent.UpdateWorkshopRatingsForResourceObject(theObject, workshopRef, bRemoveObject)
	endif

endFunction


function TryToAssignResourceType(WorkshopScript workshopRef, ActorValue resourceValue)
	;jbTrace("	TryToAssignResourceType " + resourceValue)
	if !resourceValue
		return
	endif

;	ObjectReference[] WorkshopActors = WorkshopParent.GetWorkshopActors(workshopRef)
	ObjectReference[] WorkshopActors = GetWorkshopSlaves(workshopRef)
	;jbTrace("		Total actors: " + WorkshopActors.length)

	; if no actors, exit
	if WorkshopActors.Length == 0
		return
	endif

	int resourceIndex = WorkshopParent.GetResourceIndex(resourceValue)

	; first, make array of workers who are assigned to this resource type
;	WorkshopNPCScript[] workers = new WorkShopNPCScript[WorkshopActors.Length]
	Actor[] slaves = new Actor[WorkshopActors.Length]

;	int maxWorkerIndex = -1
	
	int maxSlaveIndex = -1 ;jb

	; go through actor list, find workers
	int slaveIndex = 0
	while slaveIndex < WorkshopActors.Length
;		WorkshopNPCScript theActor = WorkshopActors[actorIndex] as WorkshopNPCScript
		Actor theSlave = WorkshopActors[slaveIndex] as Actor
;		int sInd = JBSlaveCollection.Find(theSlave)
;		if sInd > -1
			;jbTrace("		actor " + theSlave + " assigned to " + resourceValue + "? " + (WorkshopParent.GetRatingAV(theSlave.GetValue(JBassignedMultiResource) as int) == resourceValue) )
;			if theSlave && WorkshopParent.WorkshopRatingValues[theSlave.GetValue(JBassignedMultiResource) as int] == resourceValue && theSlave.GetValue(JBmultiResourceProduction) < WorkshopParent.WorkshopRatings[resourceIndex].maxProductionPerNPC
			if theSlave && WorkshopParent.GetRatingAV(theSlave.GetValue(JBassignedMultiResource) as int) == resourceValue && theSlave.GetValue(JBmultiResourceProduction) < WorkshopParent.WorkshopRatings[resourceIndex].maxProductionPerNPC
				maxSlaveIndex += 1
				slaves[maxSlaveIndex] = theSlave
			endif
;		endif
		slaveIndex += 1
	endWhile

	;jbTrace("		Found " + (maxSlaveIndex + 1) + " actors assigned to " + resourceValue)

	; shortcut - if no workers, we're done
;	if maxWorkerIndex < 0
;	if maxWorkerIndex < 0 && maxSlaveIndex < 0

	if maxSlaveIndex < 0
		return
	endif

	; we now have an array of workers - loop through object list until we can't assign any more workers (or run out of farms)
	int objectIndex = 0
	bool availableworkers = true 	; this gets set to false if we ever loop through the actor list and find no workers left with available production slots
;	int currentWorkerIndex = 0
	
	int currentSlaveIndex = 0

	; get resources of specified type, undamaged only (no point in auto-assigning damaged objects)
	ObjectReference[] ResourceObjects = WorkshopParent.GetResourceObjects(workshopRef, resourceValue, 2)
	;jbTrace("		Found " + ResourceObjects.Length + " undamaged " + resourceValue + " objects")

	;Debug.Notification("ResourceObjects: "+ResourceObjects.Length)

	while (objectIndex < ResourceObjects.Length) && availableworkers
		WorkshopObjectScript workshopObject = ResourceObjects[objectIndex] as WorkshopObjectScript

		; this produces the resource - is it owned?
;		if workshopObject.RequiresActor() && !workshopObject.IsActorAssigned()
;		if workshopObject.RequiresActor() && !workshopObject.IsActorAssigned() && !IsActorAssigned(workshopObject)
		if workshopObject.RequiresActor() && !IsActorAssigned(workshopObject)
			float resourceRating = workshopObject.GetResourceRating(resourceValue)
			; loop through actors looking for available workers
			bool assignedResource = false
			; save starting index so we only loop once
			int startingIndex = currentSlaveIndex
			bool exitLoopS = false
			while !assignedResource && !exitLoopS
				; get the next Worker
;				WorkshopNPCScript theActor = workers[currentWorkerIndex]
				Actor theSlave = slaves[currentSlaveIndex]
;				float resourceTotal = theActor.multiResourceProduction
				float resourceTotal = theSlave.GetValue(JBmultiResourceProduction)
				;jbTrace("   	found Worker " + currentSlaveIndex + ": " + theSlave + " at " + resourceTotal + " production")
				if (resourceTotal + resourceRating <= WorkshopParent.WorkshopRatings[resourceIndex].maxProductionPerNPC)
					;jbTrace("   	found available Worker, resource rating=" + resourceRating + " - assign")
					assignedResource = true
					; I can produce this, so assign me to it
					; NOTE: resetMode = TRUE (so it skips calling this function again); addActorCheck = FALSE (since we already know this actor is assigned to this workshop)
					AssignSlaveToObject(theSlave, workshopObject, bResetMode = true, bAddActorCheck = false) 
					; add to total
					resourceTotal += resourceRating
					; save out new resource total on me
;					theActor.multiResourceProduction = resourceTotal
					theSlave.SetValue(JBmultiResourceProduction, resourceTotal)
				endif
				; get next Worker index
				currentSlaveIndex = WorkshopParent.GetNextIndex(currentSlaveIndex, maxSlaveIndex)
				; if we're back to start, exit Worker loop
				if currentSlaveIndex == startingIndex
					exitLoopS = true
				endif
			endWhile

			; if we didn't assign anything, AND the foodRating was 1 (minimum), then no workers left - we can stop looking
			if !assignedResource && resourceRating == 1
				;jbTrace("	No more workers with spare production - stop looking")
				availableWorkers = false
			endif
		endif

		objectIndex += 1
	endwhile

endFunction

; return true if actor owns a bed on this workshop
bool Function SlaveOwnsBed(WorkshopScript workshopRef, Actor actorRef)
	ObjectReference[] beds = WorkshopParent.GetBeds(workshopRef)
	int i = 0
	while i < beds.Length
		WorkshopObjectScript theBed = beds[i] as WorkshopObjectScript
		; if bed has faction owner, count that if I'm in that faction
		if IsFactionOwner(theBed, actorRef) || (theBed.IsActorAssigned() && theBed.GetAssignedActor() == actorRef)
			return true
		endif
		i += 1
	endWhile
	return false
endFunction

; utility function to wait for edit lock
; increase wait time while more threads are in here
int editLockCount = 1
function GetEditLock()
	editLockCount += 1
	while EditLock
		utility.wait(0.1 * editLockCount)
	endWhile
	EditLock = true
	editLockCount -= 1
endFunction


;********************************************************************************************************
;****************************************Other functions*************************************************
;********************************************************************************************************
Function SlaveGoHome(Actor akTargetSlave)

	Location newLocation = AddSlaveToWorkshopPlayerChoice(akTargetSlave, true, true)
;	Location newLocation = akTargetSlave.OpenWorkshopSettlementMenuEx(WorkshopAssignHome)
;	WorkshopScript workshopRef = WorkshopParent.GetWorkshopFromLocation(newLocation)
;	If workshopRef
	If newLocation
		;SlaveRelax(akTargetSlave, true)
		int aliasIndex = IsSlaveFollower(akTargetSlave)
		If aliasIndex != -1
			If bAllowTeleportToInstitute
				JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
				Follower.UnregisterForPlayerTeleport()
			EndIf
			If Product.GetActorRef() == akTargetSlave
				RemoveFromSale()
			EndIf
			JBSlaveFollower[aliasIndex].Clear()
		EndIf
		If JBSlaveFollowersCollection.Find(akTargetSlave) > -1
			JBSlaveFollowersCollection.RemoveRef(akTargetSlave)
		EndIf
		If JBProstituteSlaveCollection.Find(akTargetSlave) > -1
			SetAsProstitute(akTargetSlave, false)
		EndIf
		If JBWorkshopSlaveCollection.Find(akTargetSlave) < 0
			JBWorkshopSlaveCollection.addRef(akTargetSlave)
		EndIf
		SetCommandMode(akTargetSlave, false)
		; akTargetSlave.SetCanDoCommand(false)
		; akTargetSlave.SetCommandState(false)
		; akTargetSlave.SetPlayerTeammate(false)
		;akTargetSlave.SetValue(JBIsWorkStatus, 5)
		akTargetSlave.EvaluatePackage()
	EndIf

EndFunction


Function SlaveFollow(Actor akTargetSlave)
	int aliasIndex = GetEmptySlaveFollowerIndex()
	If aliasIndex == -1
		return
	Else
		JBSlaveFollower[aliasIndex].ForceRefTo(akTargetSlave)
		If bAllowTeleportToInstitute
			JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
			Follower.RegisterForPlayerTeleport()
		EndIf
	EndIf

	If GetWorkshopID(akTargetSlave) > -1
		RemoveSlaveFromWorkshopPUBLIC(akTargetSlave)
		;UnassignSlave(akTargetSlave, true, false)
	EndIf

	SetCommandMode(akTargetSlave)
	; akTargetSlave.SetCanDoCommand()
	; akTargetSlave.SetCommandState(true)
	; akTargetSlave.SetPlayerTeammate(true)
	akTargetSlave.SetValue(JBIsWorkStatus, 3)

	If JBWorkshopSlaveCollection.Find(akTargetSlave) > -1
		JBWorkshopSlaveCollection.RemoveRef(akTargetSlave)
	EndIf
	If JBProstituteSlaveCollection.Find(akTargetSlave) > -1
		SetAsProstitute(akTargetSlave, false)
	EndIf
	If JBSlaveFollowersCollection.Find(akTargetSlave) < 0
		JBSlaveFollowersCollection.addRef(akTargetSlave)
	EndIf

	akTargetSlave.EvaluatePackage()

EndFunction


Function SlaveRelax(Actor akTargetSlave)
	int aliasIndex = IsSlaveFollower(akTargetSlave)
	If aliasIndex != -1
		If bAllowTeleportToInstitute
			JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
			Follower.UnregisterForPlayerTeleport()
		EndIf
		If Product.GetActorRef() == akTargetSlave
			RemoveFromSale()
		EndIf
		JBSlaveFollower[aliasIndex].Clear()
	EndIf

	SetCommandMode(akTargetSlave, false)
	; akTargetSlave.SetCanDoCommand(false)
	; akTargetSlave.SetCommandState(false)
	; akTargetSlave.SetPlayerTeammate(false)

	bool workshopMode = false
	If GetWorkshopID(akTargetSlave) > -1
		workshopMode = true
	EndIf

	If workshopMode
		;akTargetSlave.SetValue(JBIsWorkStatus, 0)
		UnassignSlave(akTargetSlave)
	Else
		akTargetSlave.SetValue(JBIsWorkStatus, 4)
	EndIf

	If JBSlaveFollowersCollection.Find(akTargetSlave) > -1
		JBSlaveFollowersCollection.RemoveRef(akTargetSlave)
	EndIf

	If JBProstituteSlaveCollection.Find(akTargetSlave) > -1
		SetAsProstitute(akTargetSlave, false)
		If workshopMode
			JBWorkshopSlaveCollection.AddRef(akTargetSlave)
		EndIf
	EndIf

	akTargetSlave.EvaluatePackage()

EndFunction


Function InitSlave(Actor akNewSlave)
	int aliasIndex = GetEmptySlaveFollowerIndex()
	If aliasIndex == -1
		akNewSlave.SetValue(JBIsWorkStatus, 4)
	Else
		JBSlaveFollowersCollection.addRef(akNewSlave)
		JBSlaveFollower[aliasIndex].ForceRefTo(akNewSlave)
		If bAllowTeleportToInstitute
			JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
			Follower.RegisterForPlayerTeleport()
		EndIf
		akNewSlave.SetValue(JBIsWorkStatus, 3)
		SetCommandMode(akNewSlave)
	EndIf
	JBSlaveCollection.addRef(akNewSlave)
	int sCount = JBSlaveCollection.GetCount()
	Debug.Notification((JBSlaveCountMSG as Form).GetName()+" "+sCount)
	;Debug.Notification("Slave count: "+sCount)
;	int sInd = JBSlaveCollection.Find(akNewSlave)
	If JBbCountsForPopulation.GetValueInt() == 1
		akNewSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 1)
	Else
		akNewSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 0)
	EndIf
	If SlaveDontUseAmmo
		akNewSlave.AddKeyword(TeammateDontUseAmmoKeyword)
	EndIf
	akNewSlave.SetValue(JBmultiResourceProduction, 0.0)
	;akNewSlave.SetValue(JBIsWorkStatus, 3)
	akNewSlave.SetValue(JBslaveVendorType, -1)
	SetWorkshopID(akNewSlave, -1)
	SetWounded(akNewSlave, false)
	CancelTimerGameTime(slaveStatsTimerID)
	StartTimerGameTime(updateSlaveStatsInterval, slaveStatsTimerID)
EndFunction

;Function ClearSlaveWorkshopParam(int iIndex)
;
;EndFunction

Function UpdateSubmissive()
;	Debug.Notification("UpdateSubmissive")
	int count = JBSlaveCollection.GetCount()
	If count > 0
		int i = 0
		While i < count
			Actor akSlave = JBSlaveCollection.GetActorAt(i)
			If akSlave.GetValue(JBIsSubmissive) < 100
				int iWorker = akSlave.GetValue(JBbIsWorker) as int
				int iWorkStatus = akSlave.GetValue(JBIsWorkStatus) as int
				If iWorker == 0 && iWorkStatus == 0
					akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.1)
				ElseIf iWorker == 1 && !akSlave.HasKeyword(JBSlaveRestricted) ; && iWorkStatus < 0
					akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.3)
				ElseIf iWorker == 1 && akSlave.HasKeyword(JBSlaveRestricted)
					akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+1.0)
				ElseIf iWorker == 0 && iWorkStatus == 3
					akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.5)
				ElseIf iWorker == 0 && iWorkStatus == 4
					akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.2)
				EndIf
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction

Function CheckToEscape()
	;Debug.Notification("CheckToEscape")
	int count = JBSlaveCollection.GetCount()
	If count > 0
		int i = 0
		While i < count
			Actor akSlave = JBSlaveCollection.GetActorAt(i)
			If akSlave.GetValue(JBIsSubmissive) < 100
				float rand = Utility.RandomInt()
				float s = akSlave.GetValue(JBIsSubmissive)
				If (s - rand) < 0 && !JBEscapeQuest.IsRunning() && !akSlave.IsInLocation(Game.GetPlayer().GetCurrentLocation()) && !akSlave.HasKeyword(JBSlaveRestricted) && JBSlaveFollowersCollection.Find(akSlave) < 0
					JBEscapeQuest.SetStage(10)
					;UnassignSlave(akSlave, true)
					RemoveSlaveFromWorkshopPUBLIC(akSlave)
					If JBWorkshopSlaveCollection.Find(akSlave) > -1
						JBWorkshopSlaveCollection.RemoveRef(akSlave)
					EndIf
					If JBProstituteSlaveCollection.Find(akSlave) > -1
						SetAsProstitute(akSlave, false)
					EndIf
					JBSlaveCollection.RemoveRef(akSlave)
					runawaySlave.ForceRefTo(akSlave)
					akSlave.AllowPCDialogue(false)
					akSlave.EvaluatePackage()
				EndIf
			EndIf
			i += 1
		EndWhile
	EndIf
EndFunction


Function StopEscape(Actor akActor)
	akActor.ResetHealthAndLimbs()
	akActor.SetNoBleedoutRecovery(false)
	runawaySlave.Clear()
	int aliasIndex = GetEmptySlaveFollowerIndex()
	If aliasIndex == -1
		akActor.SetValue(JBIsWorkStatus, 4)
	Else
		JBSlaveFollowersCollection.addRef(akActor)
		JBSlaveFollower[aliasIndex].ForceRefTo(akActor)
		If bAllowTeleportToInstitute
			JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
			Follower.RegisterForPlayerTeleport()
		EndIf
		akActor.SetValue(JBIsWorkStatus, 3)
		SetCommandMode(akActor)
	EndIf
	;SetCommandMode(akActor)
	; akActor.SetCanDoCommand()
	; akActor.SetCommandState(true)
	; akActor.SetPlayerTeammate(true)
	JBSlaveCollection.addRef(akActor)
	;JBSlaveFollowersCollection.addRef(akActor)
	int sCount = JBSlaveCollection.GetCount()
	Debug.Notification((JBSlaveCountMSG as Form).GetName()+sCount)
	;Debug.Notification("Slave count: "+sCount)
	akActor.SetValue(JBIsSubmissive, akActor.GetValue(JBIsSubmissive)+20)
	;akActor.SetValue(JBIsWorkStatus, 3)
	akActor.EvaluatePackage()
EndFunction

Function SetCountForPopulation(float bCount)
	int sCount = JBSlaveCollection.GetCount()
	int sIndex = 0
	If (bCount as bool)
		If sCount > 0
			While sIndex < sCount
				Actor thisSlave = JBSlaveCollection.GetAt(sIndex) as Actor
				If GetWorkshopID(thisSlave) > -1
					WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(thisSlave))
					thisSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 1)
					workshopRef.RecalculateWorkshopResources()
				ElseIf GetWorkshopID(thisSlave) < 0
					thisSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 1)
				EndIf
			sIndex += 1
			EndWhile
		EndIf
		;Debug.Notification("Counts For Population - ON")
		JBCountsForPopulationON.Show()
		;JBbCountsForPopulation.SetValueInt(1)
	Else
		If sCount > 0
			While sIndex < sCount
				Actor thisSlave = JBSlaveCollection.GetAt(sIndex) as Actor
				If GetWorkshopID(thisSlave) > -1
					WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(thisSlave))
					thisSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 0)
					workshopRef.RecalculateWorkshopResources()
				ElseIf GetWorkshopID(thisSlave) < 0
					thisSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulation].resourceValue, 0)
				EndIf
			sIndex += 1
			EndWhile
		EndIf
		;Debug.Notification("Counts For Population - OFF")
		JBCountsForPopulationOFF.Show()
		;JBbCountsForPopulation.SetValueInt(0)
	EndIf
EndFunction


ObjectReference[] Function GetWorkshopSlaves(WorkshopScript workshopRef)
	int sCount = JBSlaveCollection.GetCount()
	int sIndex = 0
;	int wIndex = WorkshopParent.GetWorkshopID(workshopRef)
	ObjectReference[] slaves = new ObjectReference[0]
	While sIndex < sCount
		Actor thisSlave = JBSlaveCollection.GetAt(sIndex) as Actor
		If GetWorkshopID(thisSlave) == workshopRef.GetWorkshopID()
			slaves.Add(thisSlave)
		EndIf
		sIndex += 1
	EndWhile
	Return slaves
endFunction

Function JBSlaveTrackingSwitch (float bTracking)
	if (bTracking as bool)
		;SetStage(10)
		SetObjectiveDisplayed(10, true, true)
		;SetObjectiveDisplayed(15, true, true)
	Else
		;SetStage(15)
		SetObjectiveDisplayed(10, false)
		;SetObjectiveDisplayed(15, false)
	EndIf
EndFunction

Function SetSlaveDontUseAmmo(bool bSet)
	int index = 0
	If bSet
		while (index < JBSlaveCollection.GetCount())
			actor theActor = JBSlaveCollection.GetActorAt(index)
			if theActor
				theActor.AddKeyword(TeammateDontUseAmmoKeyword)
			endif
			index += 1
		endwhile
		SlaveDontUseAmmo = true
	Else
		while (index < JBSlaveCollection.GetCount())
			actor theActor = JBSlaveCollection.GetActorAt(index)
			if theActor
				theActor.RemoveKeyword(TeammateDontUseAmmoKeyword)
			endif
			index += 1
		endwhile
		SlaveDontUseAmmo = false
	EndIf
	;Debug.Notification("Slave dont use ammo = "+JBSlaveCollection.GetActorAt(0).HasKeyword(TeammateDontUseAmmoKeyword))
EndFunction

Function checkAssignSlave(WorkshopObjectScript assignedObject)
	;Debug.Notification("checkAssignSlave - Start")

	If !assignedObject.HasMultiResource()
		UnassignObjectFinally(assignedObject)
	ElseIf currentMultiResObject.GetReference() == assignedObject
		UnassignObjectFinally(assignedObject)
		currentMultiResObject.Clear()
	Else
		ReassignSlave(assignedObject)
	EndIf

EndFunction

Function ReassignSlave(WorkshopObjectScript assignedObject)
	;Debug.Notification("ReassignSlave - Start")

	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(assignedObject.workshopID)
	ActorValue resourceValue = assignedObject.GetMultiResourceValue()
	WorkshopNPCScript assignedSettler = assignedObject.GetAssignedActor()
	Actor assignedSlave = assignedObject.GetLinkedRef(JBSlaveWorkObject) as Actor

	float fObject = assignedObject.GetResourceRating(resourceValue)
	If assignedSettler
		assignedSettler.multiResourceProduction = (assignedSettler.multiResourceProduction - fObject)
	EndIf
	float fSlave = assignedSlave.GetValue(JBmultiResourceProduction)
	assignedSlave.SetValue(JBmultiResourceProduction, fSlave - fObject)
	AssignSlaveToObject(assignedSlave, assignedObject, bResetMode = true, bAddActorCheck = false)

	If assignedSettler && assignedSettler.multiResourceProduction < WorkshopParent.WorkshopRatings[WorkshopParent.GetResourceIndex(assignedSettler.assignedMultiResource)].maxProductionPerNPC
		ReassignSettler(assignedSettler, resourceValue)
	EndIf
	
EndFunction

Function ReassignSettler(WorkshopNPCScript assignedSettler, ActorValue resourceValue)
	;Debug.Notification("ReassignSettler - Start")
	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(assignedSettler.GetWorkshopID())

	WorkshopObjectScript workshopObject = GetReassignedObject(workshopRef, resourceValue)
	If workshopObject != None
		WorkshopParent.AssignActorToObject(assignedSettler, workshopObject, bResetMode = true, bAddActorCheck = false)
	EndIf

EndFunction

WorkshopObjectScript Function GetReassignedObject(WorkshopScript workshopRef, ActorValue resourceValue)
	ObjectReference[] ResourceObjects = WorkshopParent.GetResourceObjects(workshopRef, resourceValue, 2)
	If ResourceObjects.Length == 0
		return None
	Else
		ObjectReference[] anassignResourceObjects = new ObjectReference[0]
		int objectIndex = 0
		While (objectIndex < ResourceObjects.Length)
			WorkshopObjectScript workshopObject = ResourceObjects[objectIndex] as WorkshopObjectScript
			If workshopObject.RequiresActor() && !IsActorAssigned(workshopObject)
				anassignResourceObjects.Add(workshopObject)
			EndIf
			objectIndex += 1
		EndWhile
		If anassignResourceObjects.Length == 0
			return None
		Else
			return anassignResourceObjects[anassignResourceObjects.Length - 1] as WorkshopObjectScript
		EndIf
	EndIf
EndFunction

Function UnassignObjectFinally(WorkshopObjectScript assignedObject)
	;Debug.Notification("UnassignObjectFinally - Start")

	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(assignedObject.workshopID)
	
	Actor assignedSlave = assignedObject.GetLinkedRef(JBSlaveWorkObject) as Actor
	If assignedSlave
		assignedObject.SetLinkedRef(None, JBSlaveWorkObject)

		; clear link if it exists
		if assignedObject.AssignedActorLinkKeyword
			assignedSlave.SetLinkedRef(NONE, assignedObject.AssignedActorLinkKeyword)
		endif

		if assignedObject.VendorType > -1
			SetVendorData(workshopRef, assignedSlave, assignedObject, false)
		endif

		;If assignedObject.HasKeyword(DLC05AnimFurnPillory)
		If JBRestrictList.HasForm(assignedObject.GetBaseObject())
			;Debug.Notification("JBSlaveRestricted - Remove")
			assignedSlave.RemoveKeyword(JBSlaveRestricted)
		EndIf

		If assignedObject.HasResourceValue(DLC02WorkshopRatingArenaPlatform)
			AssignArenaCombatant(assignedObject, assignedSlave, false)
			UnregisterForRemoteEvent(assignedSlave, "OnDying")
		EndIf

		If assignedObject.GetBaseObject() == DLC06WorkshopBarberChair as Form
			AssignBarberVendor(assignedObject, assignedSlave, false)
		EndIf

		If assignedObject.GetBaseObject() == DLC06WorkshopSurgeryChair as Form
			AssignSurgeryVendor(assignedObject, assignedSlave, false)
		EndIf

		; is does my owner own anything else?
		ObjectReference[] ResourceObjects = workshopRef.GetWorkshopOwnedObjects(assignedSlave)
		int i = 0
		bool ownedObject = false
		while i < ResourceObjects.Length && ownedObject == false
			WorkshopObjectScript resourceObject = ResourceObjects[i] as WorkshopObjectScript
			if resourceObject && resourceObject.IsBed() == 0
				; exit loop
				ownedObject = true
			endif
			i += 1
		endWhile

		if ownedObject == false

			if assignedObject.bWork24Hours
				assignedSlave.SetValue(JBbWork24Hours, 0)
			endif

			; this was the only thing I owned - add owner back to unassigned actor list
			assignedSlave.SetValue(WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingPopulationUnassigned].resourceValue, 1)
			SetMultiResource(assignedSlave, NONE)
			SetWorker(assignedSlave, false)
		endif
	EndIf
EndFunction

Faction[] Function GetCombatantFactions(WorkshopObjectScript assignedObject)
	Faction[] arr = new Faction[2]
	If assignedObject.GetBaseObject() == DLC02WorkshopArenaCombatantA as Form
		arr[0] = DLC02WorkshopArenaCombatantFaction
		arr[1] = DLC02WorkshopArenaCombatantEnemyFaction
	Else
		arr[0] = DLC02WorkshopArenaCombatantEnemyFaction
		arr[1] = DLC02WorkshopArenaCombatantFaction
	EndIf
	return arr
EndFunction

Function SetCommandMode(Actor akSlave, bool bSet = true)
	akSlave.SetCanDoCommand(bSet)
	akSlave.SetCommandState(bSet)
	akSlave.SetPlayerTeammate(bSet)
EndFunction

Function JBSlaveInfoMessage(Actor akActor)
	int ButtonPressed = JBSlaveInfoMessageBox.Show()
	if ButtonPressed == 0
		Debug.MessageBox((JBlabelNameMSG as Form).GetName()+" "+akActor.GetDisplayName()+"<br>"+(JBlabelSubmissiveMSG as Form).GetName()+" "+akActor.GetValue(JBIsSubmissive)+"<br>"+(JBlabelSexSkillMSG as Form).GetName()+" "+akActor.GetValue(JBSlaveSexSkill)+"<br>"+(JBlabelProstituteSkillMSG as Form).GetName()+" "+akActor.GetValue(JBSlaveProstituteSkill))
		;Debug.MessageBox("Name: "+akActor.GetDisplayName()+"<br>Submission: "+akActor.GetValue(JBIsSubmissive))
	ElseIf ButtonPressed == 1
		RenameSlave(akActor)
	ElseIf ButtonPressed == 2
		If akActor.IsInPowerArmor() == false
			EditSlaveLook(akActor)
		EndIf
	ElseIf ButtonPressed == 3
		ResetSlave(akActor)
	EndIf
EndFunction

Function ResetSlave(Actor akTarget)
	If JBQuartermasteryAlias.GetActorReference() == akTarget
		AssignedQuartermastery(akTarget, false)
	EndIf
	SlaveRelax(akTarget)
	JBSlaveCollection.RemoveRef(akTarget)
	If JBWorkshopSlaveCollection.Find(akTarget) > -1
		JBWorkshopSlaveCollection.RemoveRef(akTarget)
	EndIf

	ActorBase baseClone = GetSlaveBase(akTarget)
	
	Actor akTargetClone = akTarget.PlaceAtMe(baseClone, 1, true, false, false) as Actor
	akTargetClone.SetAlpha(0)

	akTargetClone.RemoveFromAllFactions()
	akTargetClone.SetValue(Game.GetAggressionAV(), -1)
	akTargetClone.SetValue(Morality, 0)
	akTargetClone.SetValue(Assistance, 0)
	akTargetClone.AddToFaction(JBSlaveFaction)
	
	If !akTarget.GetActorBase().IsUnique()
		String name = akTarget.GetDisplayName()
		String cloneName = akTargetClone.GetDisplayName()
		If name && name != cloneName
			SetRefName(akTargetClone as ObjectReference, name)
		EndIf
	EndIf
	
	akTargetClone.RemoveAllItems()

	int index = 6
	;int index = 11
	int end = 15 const
	While index <= end
		Actor:WornItem wornItem = akTarget.GetWornItem(index)
		akTargetClone.EquipItem(wornItem.Item)
		index += 1
	EndWhile

	akTarget.RemoveAllItems(akTargetClone)
	;akTarget.SetOutfit(None)
	If akTarget.IsInPowerArmor()
		;Debug.Notification("IsInPowerArmor = true")
		ObjectReference pArmor = akTarget.PlaceAtMe(PowerArmorFrameFurnitureNoCore, 1, TRUE)
		akTargetClone.SwitchToPowerArmor(pArmor)
	EndIf
	;akTargetClone.RemoveFromAllFactions()
	;akTargetClone.SetValue(Game.GetAggressionAV(), -1)
	;akTargetClone.SetValue(Morality, 0)
	;akTargetClone.SetValue(Assistance, 0)
	;akTargetClone.AddToFaction(JBSlaveFaction)
	akTargetClone.EquipItem(Collar, true)
	
	InitSlave(akTargetClone)
	
	akTargetClone.SetActivateTextOverride(JBMsgSlaveActivate)

	akTargetClone.SetValue(JBIsSubmissive, akTarget.GetValue(JBIsSubmissive))
	akTargetClone.SetValue(JBSlaveSexSkill, akTarget.GetValue(JBSlaveSexSkill))
	akTargetClone.SetValue(JBSlaveProstituteSkill, akTarget.GetValue(JBSlaveProstituteSkill))

	Utility.Wait(2.0)

	akTargetClone.SetAlpha(1)
;	akTargetClone.StopCombatAlarm()
	akTargetClone.EvaluatePackage()

	akTargetClone.StopCombat()
	akTargetClone.StopCombatAlarm()
	
	akTarget.KillEssential()
	If (akTarget.IsDead() == True); && (RemoveCorpse == true)
		;akTarget.MoveTo(JBdeadXRef)
		akTarget.Disable()
	EndIf
EndFunction

ActorBase Function GetSlaveBase(Actor akTarget)
	ActorBase TargetBase = akTarget.GetLeveledActorBase().GetTemplate()
	If (!TargetBase)
		TargetBase = akTarget.GetActorBase()
	EndIf
	Return TargetBase
EndFunction

InputEnableLayer SlaveEditLayer
Function EditSlaveLook(Actor akActor)
	editableSlave.ForceRefTo(akActor)
	RegisterForMenuOpenCloseEvent("LooksMenu")
	RegisterForLooksMenuEvent()
	; Disable movement and combat
	akActor.SetLookAt(Game.GetPlayer())
	akActor.SetPlayerControls(true)
	SlaveEditLayer = InputEnableLayer.Create()
	SlaveEditLayer.DisablePlayerControls(abCamSwitch = True)
	;make sure actor has CharGen Skeleton for editing
	akActor.SetHasCharGenSkeleton()
	;make sure actor face is neutral
	akActor.ChangeAnimFaceArchetype(None)
	akActor.PlayIdle(ElevatorFaceCamera)
	Game.ShowRaceMenu(akActor as ObjectReference)
EndFunction

Function AssignedQuartermastery(Actor akActor, bool bSet = true)
	JB:JBQuartermasteryBrahminScript Brahmin = (JBQuartermasteryBrahminRef as ObjectReference) as JB:JBQuartermasteryBrahminScript
	If bSet
		If Game.GetPlayer().HasPerk(JBWorkshopBrahminPerk) == false
			Game.GetPlayer().AddPerk(JBWorkshopBrahminPerk)
		EndIf
		Brahmin.OwnedByPlayer = true
		Brahmin.BlockActivation(false)
		JBQuartermasteryAlias.ForceRefTo(akActor)
		JBQuartermasteryBrahminRef.MoveTo(akActor)
		JBQMBrahminAlias.ForceRefTo(JBQuartermasteryBrahminRef)
		;SetWorkshopStatus(akActor, false)
		If akActor.GetValue(JBIsWorkStatus) as int != 3
			SlaveFollow(akActor)
		EndIf
		If Product.GetActorRef() == akActor
			RemoveFromSale()
		EndIf
	Else
		If Game.GetPlayer().HasPerk(JBWorkshopBrahminPerk) == true
			Game.GetPlayer().RemovePerk(JBWorkshopBrahminPerk)
		EndIf
		Brahmin.OwnedByPlayer = false
		Brahmin.BlockActivation(true)
		JBQuartermasteryAlias.Clear()
		SetWorkshopStatus(akActor, true)
	EndIf
EndFunction

Function BrahminWait(bool bSet)
	JB:JBQuartermasteryBrahminScript Brahmin = (JBQuartermasteryBrahminRef as ObjectReference) as JB:JBQuartermasteryBrahminScript
	Brahmin.bWait = bSet
	If bSet == false
		JBQuartermasteryBrahminRef.MoveToIfUnloaded(JBQuartermasteryAlias.GetReference())
	EndIf
	JBQuartermasteryBrahminRef.EvaluatePackage()
EndFunction

ObjectReference tContainer
Function QMContainer()
	;Debug.Notification("QMContainer - Start")
	tContainer = Game.GetPlayer().PlaceAtMe(JBQMTransferContainer)
	Utility.Wait(0.1)
	tContainer.Activate(Game.GetPlayer())
	RegisterForMenuOpenCloseEvent("ContainerMenu")
EndFunction

Function RenameSlave(Actor akActor)
	string label = (JBRenameLabel as Form).GetName()
	string slaveName = akActor.GetDisplayName()
	editableSlave.ForceRefTo(akActor)
	Open(1, label, slaveName)
	RegisterForExternalEvent("TIM::Accept","SetFrequency")
	RegisterForExternalEvent("TIM::Cancel","NoSetFrequency")
EndFunction

Function SetFrequency(string freq)
  ;Debug.MessageBox("frequency will set at "+ freq)
  Actor akActor = editableSlave.GetActorRef()
  SetRefName(akActor as ObjectReference, freq)
  UnRegisterForExternalEvent("TIM::Accept")
  UnRegisterForExternalEvent("TIM::Cancel")
  editableSlave.Clear()
EndFunction

Function NoSetFrequency(string freq)
  ;Debug.MessageBox("input frequency was aborted at "+ freq)
  UnRegisterForExternalEvent("TIM::Accept")
  UnRegisterForExternalEvent("TIM::Cancel")
  editableSlave.Clear()
EndFunction

; Function AllowSettlersRename(float fSet)
; 	If (fSet as bool)
; 		Game.GetPlayer().AddPerk(JBRenamePerk)
; 		;Debug.Notification("JBRenamePerk - Add")
; 	Else
; 		Game.GetPlayer().RemovePerk(JBRenamePerk)
; 		;Debug.Notification("JBRenamePerk - Remove")
; 	EndIf
; EndFunction

Function JBRenameSettlersModeSwitch()
	;If !Utility.IsInMenuMode() && !Game.GetPlayer().IsDead()
		Utility.Wait(0.1)
		If (Game.GetPlayer().HasPerk(JBRenamePerk))
			Game.GetPlayer().RemovePerk(JBRenamePerk)
			JBbIsRenameModeActivated = false
			JBRenameSettlersModeOFF.Show()
		Else
			Game.GetPlayer().AddPerk(JBRenamePerk)
			JBbIsRenameModeActivated = true
			JBRenameSettlersModeON.Show()
		EndIf
	;EndIf
EndFunction

Function ResetWorkshop(WorkshopScript workshopRef)

	;GetEditLock()

	; set current workshopID to this workshop
	;int workshopID = workshopRef.GetWorkshopID()

	ObjectReference workshopCenter = workshopRef.GetLinkedRef(WorkshopParent.WorkshopLinkCenter)

	ObjectReference[] WorkshopSlaves = GetWorkshopSlaves(workshopRef)

	Location workshopLocation = workshopRef.myLocation

	int i = 0
	While i < WorkshopSlaves.length
		Actor slaveRef = WorkshopSlaves[i] as Actor
		If JBCaravanSlaveCollection.Find(slaveRef) < 0
			If workshopLocation != slaveRef.GetCurrentLocation()
				slaveRef.MoveTo(workshopCenter)
				slaveRef.EvaluatePackage()
			EndIf
		EndIf
		i += 1
	EndWhile

	ObjectReference[] ResourceObjectsUndamaged = WorkshopParent.GetResourceObjects(workshopRef, NONE, 2)

	;ActorValue rValue = WorkshopParent.WorkshopRatings[WorkshopParent.WorkshopRatingFood].resourceValue
	;ObjectReference[] ResourceObjects = WorkshopParent.GetResourceObjects(workshopRef, rValue, 2)
	If ResourceObjectsUndamaged.Length > 0
		i = 0
		While i < ResourceObjectsUndamaged.Length
			WorkshopObjectScript workshopObject = ResourceObjectsUndamaged[i] as WorkshopObjectScript
			If workshopObject.GetLinkedRef(JBSlaveWorkObject) != None
				HandleWorkshopReset(workshopObject)
			EndIf
			i +=1
		EndWhile
	EndIf

	If JBbCountsForPopulation.GetValueInt() == 0
		;ObjectReference[] ResourceObjectsUndamaged = WorkshopParent.GetResourceObjects(workshopRef, NONE, 2)

		Utility.Wait(4.0)

		i = 0
		While i < ResourceObjectsUndamaged.length
			WorkshopObjectScript resourceRef = ResourceObjectsUndamaged[i] as WorkshopObjectScript
			If resourceRef && resourceRef.GetLinkedRef(JBSlaveWorkObject) != None && resourceRef.GetLinkedRef(JBSlaveWorkObject) != resourceRef.GetActorRefOwner()
				AssignSlave(resourceRef, resourceRef.GetLinkedRef(JBSlaveWorkObject) as Actor)
			EndIf
			i += 1
		EndWhile
	EndIf

	;EditLock = false

EndFunction

float floraResetHarvestDays = 1.0 const				; how many game days to reset harvestable flora?
; called on workshop objects during reset
function HandleWorkshopReset(WorkshopObjectScript workshopObject)
	; since workshop locations don't reset, do it manually
	float harvestTime = workshopObject.GetValue(WorkshopParent.WorkshopFloraHarvestTime)
	if workshopObject.GetBaseObject() as Flora
		;WorkshopParent.wsTrace(self + " HandleWorkshopReset: last harvest time=" + harvestTime +", IsActorAssigned=" + IsActorAssigned() + ", current time=" + utility.GetCurrentGameTime())
		if Utility.GetCurrentGameTime() > (harvestTime + floraResetHarvestDays)
			workshopObject.SetHarvested(false)
		endif
	endif
endFunction

Function PlayerSlaveSex(Actor akSlave)
	Actor PlayerRef = Game.GetPlayer()
	If (akSlave.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(akSlave) > -1)
		akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.3)
	EndIf

	;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
	Actor[] actors = new Actor[2]
	; actors[0] = PlayerRef
	; actors[1] = akSlave
	actors[0] = akSlave
	actors[1] = PlayerRef

	StartSexScene(actors, akSlave)

	;AAF_API.QuickScene(actors, sexDuration, true)
	;four_play:Main.GetAPI().four_play(PlayerRef, akSlave, false ,akSlave, sexDuration) ;FP
EndFunction

Function CompanionSlaveSex(Actor akSlave)
	Actor CompanionRef = Companion.GetActorReference()
	If (akSlave.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(akSlave) > -1)
		akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.3)
	EndIf
	;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
	Actor[] actors = new Actor[2]
	; actors[0] = CompanionRef
	; actors[1] = akSlave
	actors[0] = akSlave
	actors[1] = CompanionRef

	StartSexScene(actors, akSlave)

	;AAF_API.QuickScene(actors, sexDuration, true)
	;four_play:Main.GetAPI().four_play(CompanionRef, akSlave, false ,akSlave, sexDuration) ;FP
EndFunction

Function PlayerCompanionSlaveSex(Actor akSlave)
	Actor PlayerRef = Game.GetPlayer()
	Actor CompanionRef = Companion.GetActorReference()
	If (akSlave.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(akSlave) > -1)
		akSlave.SetValue(JBIsSubmissive, akSlave.GetValue(JBIsSubmissive)+0.3)
	EndIf
	;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
	Actor[] actors = new Actor[3]
	; actors[0] = PlayerRef
	; actors[1] = akSlave
	; actors[2] = CompanionRef
	actors[0] = akSlave
	actors[1] = PlayerRef
	actors[2] = CompanionRef

	StartSexScene(actors)

	;AAF_API.QuickScene(actors, sexDuration, true)
	;four_play:Main.GetAPI().three_play(PlayerRef, akSlave, CompanionRef, akPreventBed=false, akVictim=none, duration = sexDuration) ;FP
EndFunction

Function AddSlaveToTwoSlaveSexAction(Actor akSlave)
	If SlaveForSexA.GetReference() == None
		SlaveForSexA.ForceRefTo(akSlave)
	ElseIf SlaveForSexB.GetReference() == None
		SlaveForSexB.ForceRefTo(akSlave)
	EndIf
	Utility.Wait(0.2)
	If SlaveForSexA.GetReference() != None && SlaveForSexB.GetReference() != None
		TwoSlaveSex()
	EndIf
EndFunction

Function TwoSlaveSex()
	Actor SlaveA = SlaveForSexA.GetActorReference()
	Actor SlaveB = SlaveForSexB.GetActorReference()
	If (SlaveA.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(SlaveA) > -1)
		SlaveA.SetValue(JBIsSubmissive, SlaveA.GetValue(JBIsSubmissive)+0.2)
	EndIf
	If (SlaveB.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(SlaveB) > -1)
		SlaveB.SetValue(JBIsSubmissive, SlaveB.GetValue(JBIsSubmissive)+0.2)
	EndIf
	;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
	Actor[] actors = new Actor[2]
	actors[0] = SlaveA
	actors[1] = SlaveB

	StartSexScene(actors)

	;AAF_API.QuickScene(actors, sexDuration, true)
	;four_play:Main.GetAPI().four_play(SlaveA, SlaveB, false, none, sexDuration) ;FP
	SlaveForSexA.Clear()
	SlaveForSexB.Clear()
EndFunction

Function ProstituteCustomerSex()
	;UnregisterForDistanceEvents(SlaveProstitute, clientForProstitute)
	Actor Customer = clientForProstitute.GetActorReference()
	Actor Prostitute = SlaveProstitute.GetActorReference()

	int price = CalculateCostProstitute(Prostitute)
	;Debug.Notification("price = "+price)
	Prostitute.AddItem(Caps001, price)

	If (Prostitute.GetValue(JBIsSubmissive) < 100) && (JBSlaveCollection.Find(Prostitute) > -1)
		Prostitute.SetValue(JBIsSubmissive, Prostitute.GetValue(JBIsSubmissive)+0.3)
	EndIf

	;AAF_API = Game.GetFormFromFile(0x01000F99, "AAF.esp") as AAF:AAF_API ;AAF
	Actor[] actors = new Actor[2]
	;actors[0] = Customer
	;actors[1] = Prostitute
	actors[0] = Prostitute
	actors[1] = Customer

	StartSexScene(actors)

	;AAF_API.QuickScene(actors, sexDuration, true)

	clientForProstitute.Clear()
	SlaveProstitute.Clear()
EndFunction

Function ProstituteCustomerNoSex()
	;Actor Customer = clientForProstitute.GetActorReference()
	Actor Prostitute = SlaveProstitute.GetActorReference()
	clientForProstitute.Clear()
	SlaveProstitute.Clear()
	int index = SlavesData.FindStruct("Slave", Prostitute)
	If index > -1
		SlaveData sd = SlavesData[index]
		StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
	EndIf
EndFunction

Function SetAsProstitute(Actor akSlave, bool bSet)
	If bSet
		;Debug.Notification("Slave set as prostitute")
		int aliasIndex = IsSlaveFollower(akSlave)
		If aliasIndex != -1
			If bAllowTeleportToInstitute
				JB:JBSlaveFollowerScript Follower = JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
				Follower.UnregisterForPlayerTeleport()
			EndIf
			If Product.GetActorRef() == akSlave
				RemoveFromSale()
			EndIf
			JBSlaveFollower[aliasIndex].Clear()
		EndIf

		SetCommandMode(akSlave, false)

		bool workshopMode = false
		If GetWorkshopID(akSlave) > -1
			workshopMode = true
		EndIf

		If workshopMode
			UnassignSlave(akSlave)
		EndIf

		If JBWorkshopSlaveCollection.Find(akSlave) > -1
			JBWorkshopSlaveCollection.RemoveRef(akSlave)
		EndIf

		If JBSlaveFollowersCollection.Find(akSlave) > -1
			JBSlaveFollowersCollection.RemoveRef(akSlave)
		EndIf

		akSlave.SetValue(JBIsWorkStatus, 6)
		JBProstituteSlaveCollection.AddRef(akSlave)

		CreateSlaveData(akSlave)

		ProstituteSearchCustomer(akSlave)

		akSlave.SetActivateTextOverride(JBMsgProstituteActivate)

		akSlave.EvaluatePackage()
	Else
		int index = SlavesData.FindStruct("Slave", akSlave)
		SlaveData sd = GetSlaveData(akSlave)
		CancelTimer(sd.timer_id)
		SlavesData.Remove(index)
		If JBProstituteSlaveCollection.Find(akSlave) > -1
			JBProstituteSlaveCollection.RemoveRef(akSlave)
		EndIf
		akSlave.SetActivateTextOverride(JBMsgSlaveActivate)
	EndIf
EndFunction

Function CreateSlaveData(Actor akSlave)
	If SlavesData.Length == 0
		SlavesData = new SlaveData[0]
	EndIf
	SlaveData sd = new SlaveData
	sd.Slave = akSlave
	sd.timer_id = Math.Abs(akSlave.GetFormID() as float) as int
	;Debug.Notification("Slave TimerID= "+sd.timer_id)
	SlavesData.Add(sd)
	;Debug.Notification("SlavesData array = "+SlavesData.Length)
EndFunction

SlaveData Function GetSlaveData(Actor akSlave)
	int index = SlavesData.FindStruct("Slave", akSlave)
	If index < 0
		return none
	Else
		SlaveData sd = SlavesData[index]
		return sd
	EndIf
EndFunction

Function ProstituteSearchCustomer(Actor akSlave)
	;Debug.Notification("Prostitue search customer - start")
	SlaveData sd = GetSlaveData(akSlave)
	If akSlave.Is3DLoaded()
		Actor Customer = Game.FindRandomActorFromRef(sd.Slave, prostituteSearchCustomerRadius)
		;Debug.Notification("Customer is "+Customer)
		If Customer && Customer.HasKeyword(ActorTypeNPC) && !Customer.IsHostileToActor(sd.Slave) && !Customer.IsInCombat() && !Customer.IsInFaction(JBSlaveFaction) && Customer != Game.GetPlayer()
			;Debug.Notification("Prostitue find customer")
			If SlaveProstitute.GetActorReference() == none
				TryToSellBody(sd.Slave, Customer)
			Else
				StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
			EndIf
		Else
			;Debug.Notification("Prostitue not find customer")
			StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
		EndIf
	Else
		If Utility.RandomInt() > 50
			int check = CalculateCustomerAgree(akSlave)
			If check < 0
				StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
			Else
				int price = CalculateCostProstitute(akSlave)
				akSlave.AddItem(Caps001, price)
				If (akSlave.GetValue(JBSlaveSexSkill) < 100) && (JBSlaveCollection.Find(akSlave) > -1)
					akSlave.SetValue(JBSlaveSexSkill, akSlave.GetValue(JBSlaveSexSkill)+0.3)
				EndIf
				If (akSlave.GetValue(JBSlaveProstituteSkill) < 100) && (JBProstituteSlaveCollection.Find(akSlave) > -1)
					akSlave.SetValue(JBSlaveProstituteSkill, akSlave.GetValue(JBSlaveProstituteSkill)+0.5)
				EndIf
				StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
			EndIf
		Else
			StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
		EndIf
	EndIf
EndFunction

Function TryToSellBody(Actor akSlave, Actor akCustomer)
	SlaveProstitute.ForceRefTo(akSlave)
	clientForProstitute.ForceRefTo(akCustomer)
	akSlave.SetValue(JBbIsWorker, 1)
	akSlave.EvaluatePackage()
	akCustomer.EvaluatePackage()
	;ProstituteCustomerSex()
EndFunction

Function ProstituteCustomerConversationStart()
	;Debug.Notification("ProstituteCustomerConversationStart")
	;int rand = Utility.RandomInt(0, 130)
	;Debug.Notification("random = "+rand)
	;int skill = Math.Floor(SlaveProstitute.GetActorReference().GetValue(JBSlaveProstituteSkill))
	;int check = (skill - rand) + 20
	;Debug.Notification("check = "+check)
	int check = CalculateCustomerAgree(SlaveProstitute.GetActorReference())
	If check < 0
		;Debug.Notification("Customer Disagree")
		JBProstituteCustomerNoScene01.Start()
	Else
		;Debug.Notification("Customer Agreed")
		JBProstituteCustomerYesScene01.Start()
	EndIf
	SlaveProstitute.GetActorReference().SetValue(JBbIsWorker, 0)
EndFunction

int Function CalculateCustomerAgree(Actor akSlave)
	int rand = Utility.RandomInt(0, 130)
	int skill = Math.Floor(akSlave.GetValue(JBSlaveProstituteSkill))
	int check = (skill - rand) + 20
	return check
EndFunction

int Function CalculateCostProstitute(Actor akSlave)
	int startCost = 5
	int sexValue = Math.Floor(Math.Sqrt(akSlave.GetValue(JBSlaveSexSkill)))
	int prostituteValue = Math.Floor(Math.Sqrt(akSlave.GetValue(JBSlaveProstituteSkill)))
	int cost = startCost * sexValue * prostituteValue
	If cost <= 0
		return startCost
	Else
		return cost
	EndIf
EndFunction

Function AllowTeleportToInstitute(bool bSet)
	int index = 0
	If bSet
		While index < JBSlaveFollower.Length
			If JBSlaveFollower[index].GetReference() != None
				JB:JBSlaveFollowerScript Follower = JBSlaveFollower[index] as JB:JBSlaveFollowerScript
				Follower.RegisterForPlayerTeleport()
			EndIf
		index += 1
		EndWhile
		bAllowTeleportToInstitute = true
	Else
		While index < JBSlaveFollower.Length
			If JBSlaveFollower[index].GetReference() != None
				JB:JBSlaveFollowerScript Follower = JBSlaveFollower[index] as JB:JBSlaveFollowerScript
				Follower.UnregisterForPlayerTeleport()
			EndIf
		index += 1
		EndWhile
		bAllowTeleportToInstitute = false
	EndIf
EndFunction

Function RemoveFromSale()
	Product.Clear()
	availableForSale = false
EndFunction

Event OnTimer(int aiTimerID)
	;Debug.Notification("Event OnTimer")
	int index = SlavesData.FindStruct("timer_id", aiTimerID)
	;Debug.Notification("Index in SlavesData array = "+index)
	If index > -1
		;Debug.Notification("Event OnTimer for Slave")
		SlaveData sd = SlavesData[index]
		ProstituteSearchCustomer(sd.Slave)
	EndIf
EndEvent

;handle actor transitioning between body and face 
Event OnLooksMenuEvent(int aiFlavor)
	;Debug.Notification("OnLooksMenuEvent - Start")
	Actor akActor = editableSlave.GetActorRef()
	;actor edits body
	If aiFlavor == 10
		akActor.PlayIdle(ElevatorBodyCamera)
	;actor edits face
	ElseIf aiFlavor == 11
		akActor.PlayIdle(ElevatorFaceCamera)
	EndIf
EndEvent

;when menus close, re-pop the main menu
Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
	;Debug.Notification("OnMenuOpenCloseEvent - Start")
	If (asMenuName == "LooksMenu") && (abOpening == False)
		;Debug.Notification("OnMenuOpenCloseEvent - LooksMenu - Close")
		Actor akActor = editableSlave.GetActorRef()
		akActor.ClearLookAt()
		akActor.SetPlayerControls(false)
		SlaveEditLayer.Delete()
		akActor.SetHasCharGenSkeleton(False)
		UnregisterForMenuOpenCloseEvent("LooksMenu")
		UnregisterForLooksMenuEvent()
		editableSlave.Clear()
    ElseIf (asMenuName == "ContainerMenu") && (abOpening == False)
    	;Debug.Notification("OnMenuOpenCloseEvent - ContainerMenu - Close")
    	JB:JBQuartermasteryBrahminScript Brahmin = (JBQuartermasteryBrahminRef as ObjectReference) as JB:JBQuartermasteryBrahminScript
    	ObjectReference brahminContainer = Brahmin.GetContainer()
    	tContainer.RemoveAllItems(brahminContainer)
    	UnregisterForMenuOpenCloseEvent("ContainerMenu")
	EndIf
EndEvent

Event WorkshopParentScript.WorkshopActorAssignedToWork(WorkshopParentScript akSender, Var[] akArgs)
	;debug.OpenUserLog(userlogName)
	;Debug.Notification("WorkshopActorAssignedToWork - Event Start")
	;jbTrace("WorkshopActorAssignedToWork - Event Start")

	WorkshopObjectScript assignedObject = akArgs[0] as WorkshopObjectScript
	WorkshopScript workshopRef = akArgs[1] as WorkshopScript

	If GetWorkshopSlaves(workshopRef).Length > 0 && assignedObject.IsActorAssigned() && assignedObject.GetLinkedRef(JBSlaveWorkObject) != None && assignedObject.GetAssignedActor() != assignedObject.GetLinkedRef(JBSlaveWorkObject)
		checkAssignSlave(assignedObject)
	EndIf

EndEvent

Event WorkshopParentScript.WorkshopObjectDestroyed(WorkshopParentScript akSender, Var[] akArgs)
	WorkshopObjectScript workObject = akArgs[0] as WorkshopObjectScript
	WorkshopScript workshopRef = akArgs[1] as WorkshopScript

	UnassignObject(workObject, true)

EndEvent

Event WorkshopParentScript.WorkshopEnterMenu(WorkshopParentScript akSender, Var[] akArgs)
	WorkshopScript workshopRef = akArgs[1] as WorkshopScript
	if workshopRef
		ObjectReference[] workshopActors = WorkshopParent.GetWorkshopActors(workshopRef)
		int count = 0
		While (count < workshopActors.Length)
			If JBbCountsForPopulation.GetValueInt() == 1
				If JBSlaveCollection.Find(workshopActors[count]) == -1
					RegisterForRemoteEvent((workshopActors[count] as Actor), "OnCommandModeGiveCommand")
				EndIf
			Else
				RegisterForRemoteEvent((workshopActors[count] as Actor), "OnCommandModeGiveCommand")
			EndIf
			count += 1
		EndWhile
		RegisterForRemoteEvent(workshopRef, "OnWorkshopMode")
	endif
	;Debug.Notification("WorkshopEnterMenu - Event")
EndEvent

Event WorkshopParentScript.WorkshopDailyUpdate(WorkshopParentScript akSender, Var[] akArgs)
	If allowEscape == true
		CheckToEscape()
	EndIf
EndEvent

Event ObjectReference.OnWorkshopMode(ObjectReference akSender, bool aStart)

		if ( aStart )
			;Debug.Notification("Workshop Mode Started")
		else
			;Debug.Notification("Workshop Mode Ended")

			WorkshopScript workshopRef = akSender as WorkshopScript

			if workshopRef
				ObjectReference[] workshopActors = WorkshopParent.GetWorkshopActors(workshopRef)
				int count = 0
				While (count < workshopActors.Length)
			If JBbCountsForPopulation.GetValueInt() == 1
				If JBSlaveCollection.Find(workshopActors[count]) == -1
					UnregisterForRemoteEvent((workshopActors[count] as Actor), "OnCommandModeGiveCommand")
				EndIf
			Else
				UnregisterForRemoteEvent((workshopActors[count] as Actor), "OnCommandModeGiveCommand")
			EndIf
					count += 1
				EndWhile
				UnregisterForRemoteEvent(workshopRef, "OnWorkshopMode")
			endif
		endif

EndEvent

Event Actor.OnCommandModeGiveCommand(Actor akActor, int aeCommandType, ObjectReference akTarget)
	;Debug.Notification("Settler - OnCommandModeGiveCommand")

	;debug.OpenUserLog(userlogName)
	;jbTrace("Settler - OnCommandModeGiveCommand - Start")

	;WorkshopNPCScript Settler = akActor as WorkshopNPCScript
	WorkshopObjectScript workObject = akTarget as WorkshopObjectScript
	;WorkshopScript workshopRef = WorkshopParent.GetWorkshop(Settler.GetWorkshopID())

	If workObject && aeCommandType == 10 ; workshop assign command
		If workObject.GetLinkedRef(JBSlaveWorkObject) != None && workObject.HasMultiResource()
			currentMultiResObject.ForceRefTo(workObject)
		EndIf
		;Debug.Notification("Settler - OnCommandModeGiveCommand - Assign command - 10")
	Else
		;Debug.Notification("Settler - OnCommandModeGiveCommand - command: " + aeCommandType)
	EndIf
	
EndEvent

Event Actor.OnDying(Actor akSender, Actor akKiller)
    ; reduce happiness if arena combatant dies
   	WorkshopScript workshopRef = WorkshopParent.GetWorkshop(GetWorkshopID(akSender))
   	if workshopRef
    	WorkshopParent.ModifyHappinessModifier(workshopRef, ArenaCombatantDeathHappinessPenalty)
    endif
EndEvent

;Event Actor.OnCommandModeEnter(Actor akActor)
	;Debug.Notification("Settler - OnCommandModeEnter")

;EndEvent

;Event Actor.OnCommandModeExit(Actor akActor)
	;Debug.Notification("Settler - OnCommandModeExit")

;EndEvent

Event Actor.OnLocationChange(Actor akSender, Location akOldLoc, Location akNewLoc)
	;;debug.trace(self + " OnLocationChange: akNewLoc=" + akNewLoc)
	if akNewLoc && akNewLoc.HasKeyword(WorkshopParent.LocTypeWorkshopSettlement)
		;wsTrace(" OnLocationChange: entered workshop settlement location " + akNewLoc)
		; when player enters a workshop location, recalc the workbench ratings
		; get the workbench
		WorkshopScript workshopRef = WorkshopParent.GetWorkshopFromLocation(akNewLoc)
		if !workshopRef || GetWorkshopSlaves(workshopRef).Length <= 0
			;wsTrace(" ERROR - OnLocationChange: failed to find workshop matching " + akNewLoc + " which has the LocTypeWorkshopSettlement keyword", 2)
			return
		else
			ResetWorkshop(workshopRef)
			; send change location script event
			; OBSOLETE - moved to always use MinRadiantStart
;			WorkshopEventChangeLocation.SendStoryEvent(akNewLoc, workshopRef)
		endif
	endif
EndEvent

Event DLC04:DLC04WorkshopParentScript.DLC04WorkshopVassalSettlementEvent(DLC04:DLC04WorkshopParentScript akSender, Var[] akArgs)
	If allowManageVassal
		WorkshopScript workshopRef = akArgs[0] as WorkshopScript
		workshopRef.myLocation.AddLinkedLocation(DLC04WorkshopParent.DLC04NukaWorldWorkshopREF.myLocation, WorkshopParent.WorkshopCaravanKeyword)
		; make player owned
		workshopRef.SetOwnedByPlayer(true)
	EndIf
EndEvent

; Event four_play:Main.animation_over(four_play:Main akSender, Var[] akArgs)
; 	Debug.Notification("animation_over event")
; EndEvent

; Event four_play:Main.animation_start(four_play:Main akSender, Var[] akArgs)
; 	Debug.Notification("animation_start event")
; EndEvent

; Event four_play:Main.animation_begin(four_play:Main akSender, Var[] akArgs)
; 	Debug.Notification("animation_begin event")
; EndEvent

Event Actor.OnPlayerLoadGame(actor aSender)
	;Debug.Notification("Event OnPlayerLoadGame")
	;Debug.Notification("UseFurniture = "+UseFurniture)
	If currentModVersion != previousModVersion
		Update()
		previousModVersion = currentModVersion
	EndIf
	RegisterCustomEvents()
	;LoadAAF()
	LoadFP()
EndEvent

Function OnMCMSettingChange(string modName, string id)
	If (modName == "Just Business")
		If (id == "JBAllowEscapeID")
			If allowEscape == false && JBEscapeQuest.IsRunning()
				Actor Slave = runawaySlave.GetActorReference()
				StopEscape(Slave)
				JBEscapeQuest.SetStage(15)
				Slave.MoveToIfUnloaded(Game.GetPlayer())
			EndIf
		EndIf
		If (id == "JBAllowVassalID")
			If allowManageVassal == true
				If DLC04WorkshopParent.VassalWorkshops != None
					int i = 0
					While i < DLC04WorkshopParent.VassalWorkshops.Length
						WorkshopScript workshopRef = DLC04WorkshopParent.VassalWorkshops[i]
						If workshopRef
							workshopRef.myLocation.AddLinkedLocation(DLC04WorkshopParent.DLC04NukaWorldWorkshopREF.myLocation, WorkshopParent.WorkshopCaravanKeyword)
							; make player owned
							workshopRef.SetOwnedByPlayer(true)
						EndIf
						i += 1
					EndWhile
				EndIf
			Else
				If DLC04WorkshopParent.VassalWorkshops != None
					int i = 0
					While i < DLC04WorkshopParent.VassalWorkshops.Length
						WorkshopScript workshopRef = DLC04WorkshopParent.VassalWorkshops[i]
						If workshopRef
							workshopRef.myLocation.RemoveLinkedLocation(DLC04WorkshopParent.DLC04NukaWorldWorkshopREF.myLocation, WorkshopParent.WorkshopCaravanKeyword)
							; make player owned
							workshopRef.SetOwnedByPlayer(false)
						EndIf
						i += 1
					EndWhile
				EndIf
			EndIf
		EndIf
	EndIf
EndFunction


;********************************************************************************************************
;****************************************Follower functions*************************************************
;********************************************************************************************************

int Function GetEmptySlaveFollowerIndex()
	int aliasIndex = -1
	int i = 0
	While i < JBSlaveFollower.Length && aliasIndex == -1
		If JBSlaveFollower[i].GetReference() == None
			aliasIndex = i
		EndIf
		i += 1
	EndWhile
	return aliasIndex
EndFunction

int Function IsSlaveFollower(Actor akSlave)
	int isFollower = -1
	int i = 0
	While i < JBSlaveFollower.Length && isFollower == -1
		If JBSlaveFollower[i].GetActorReference() == akSlave
			isFollower = i
		EndIf
		i += 1
	EndWhile
	return isFollower
EndFunction

;*********************************************************************************************************
;****************************************Sex functions*************************************************
;*********************************************************************************************************

Function StartSexScene(Actor[] actors, Actor akVictim = None)
	;Debug.Notification("Start Sex Scene")
	bool bFurniture = false
	bool bPackages = true

	If preventFurniture == 1
		bFurniture = true
	ElseIf preventFurniture == 2
		bFurniture = AskAboutFurniture()
	EndIf

	If usePackages == 1
		bPackages = false
	ElseIf usePackages == 2
		bPackages = AskAboutPackages()
	EndIf

	;AAF_API.QuickScene(actors, sexDuration, bFurniture, bPackages)

	If actors.Length > 2
		FP_API.three_play(actors[0], actors[1], actors[2], akPreventBed=false, akVictim=none, duration = sexDuration)
	Else
		FP_API.four_play(actors[0], actors[1], bFurniture ,akVictim, sexDuration)
	EndIf
EndFunction

Bool Function AskAboutFurniture()
	int ButtonPressed = JBAskAboutFurnitureMSG.Show()
	If ButtonPressed == 0
		return false
	ElseIf ButtonPressed == 1
		return true
	EndIf
EndFunction

Bool Function AskAboutPackages()
	int ButtonPressed = JBAskAboutPackagesMSG.Show()
	If ButtonPressed == 0
		return true
	ElseIf ButtonPressed == 1
		return false
	EndIf
EndFunction

; Event AAF:AAF_API.OnAnimationStop(AAF:AAF_API akSender, Var[] akArgs)
; 	;Debug.Notification("AAF Animation Stop")
; 	utility.Wait(0.2)
; 	Actor[] actors = Utility.VarToVarArray(akArgs[1]) as Actor[]
; 	;Debug.Notification("Quest actors - "+actors.Length)
; 	int i = 0
; 	While i < actors.Length
; 		Actor akActor = actors[i] as Actor
; 		If akActor
; 			If (akActor.GetValue(JBSlaveSexSkill) < 100) && (JBSlaveCollection.Find(akActor) > -1)
; 				akActor.SetValue(JBSlaveSexSkill, akActor.GetValue(JBSlaveSexSkill)+0.3)
; 			EndIf
; 			If (akActor.GetValue(JBSlaveProstituteSkill) < 100) && (JBProstituteSlaveCollection.Find(akActor) > -1)
; 				akActor.SetValue(JBSlaveProstituteSkill, akActor.GetValue(JBSlaveProstituteSkill)+0.5)
; 			EndIf
; 			int index = SlavesData.FindStruct("Slave", akActor)
; 			If index > -1
; 				SlaveData sd = SlavesData[index]
; 				StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
; 			EndIf
; 			If akActor.HasMagicEffect(JBMarkEffect)
; 				;Debug.Notification("Actor has JBMarkEffect")
; 				akActor.SetNoBleedoutRecovery(true)
; 				akActor.Kill()
; 			EndIf
; 		EndIf
; 		i += 1
; 	EndWhile
; EndEvent

Event four_play:Main.animation_over(four_play:Main akSender, Var[] akArgs)
	int i = 0
	While i < 3
		Actor akActor = akArgs[i] as Actor
		If akActor
			If (akActor.GetValue(JBSlaveSexSkill) < 100) && (JBSlaveCollection.Find(akActor) > -1)
				akActor.SetValue(JBSlaveSexSkill, akActor.GetValue(JBSlaveSexSkill)+0.3)
			EndIf
			If (akActor.GetValue(JBSlaveProstituteSkill) < 100) && (JBProstituteSlaveCollection.Find(akActor) > -1)
				akActor.SetValue(JBSlaveProstituteSkill, akActor.GetValue(JBSlaveProstituteSkill)+0.5)
			EndIf
			int index = SlavesData.FindStruct("Slave", akActor)
			If index > -1
				SlaveData sd = SlavesData[index]
				StartTimer(prostituteSearchCustomerInterval, sd.timer_id)
			EndIf
			If akActor.HasMagicEffect(JBMarkEffect)
				;Debug.Notification("Actor has JBMarkEffect")
				akActor.SetNoBleedoutRecovery(true)
				akActor.Kill()
			EndIf
		EndIf
		i += 1
	EndWhile
EndEvent

;*********************************************************************************************************
;****************************************Update functions*************************************************
;*********************************************************************************************************

Function RegisterCustomEvents()
	RegisterForRemoteEvent(Game.GetPlayer(), "OnLocationChange")
	RegisterForCustomEvent(WorkshopParent, "WorkshopEnterMenu")
	RegisterForCustomEvent(WorkshopParent, "WorkshopActorAssignedToWork")
	RegisterForCustomEvent(WorkshopParent, "WorkshopDailyUpdate")
	RegisterForCustomEvent(WorkshopParent, "WorkshopObjectDestroyed")
	;RegisterForCustomEvent(DLC04WorkshopParent, "DLC04WorkshopRaiderSettlementEvent")
	RegisterForCustomEvent(DLC04WorkshopParent, "DLC04WorkshopVassalSettlementEvent")
	RegisterForExternalEvent("OnMCMSettingChange|Just Business", "OnMCMSettingChange")
EndFunction

; Function LoadAAF()
;     Quest AAF_MainQuest = Game.GetFormFromFile(0x00000F99, "AAF.esm") as Quest
;     If !AAF_MainQuest
;         Debug.Notification("Can't find AAF.")
;         utility.wait(0.1)
;     Else
;     	;Debug.Notification("AAF Registered")
;         AAF_API = AAF_MainQuest as AAF:AAF_API
;         ;RegisterForCustomEvent(AAF_API, "OnAnimationStart")
;         ;RegisterForCustomEvent(AAF_API, "OnAnimationChange")
;         RegisterForCustomEvent(AAF_API, "OnAnimationStop")
;     Endif
; EndFunction

Function LoadFP()
    Quest FP_MainQuest = Game.GetFormFromFile(0x00002679, "four_play.esp") as Quest
    If !FP_MainQuest
        Debug.Notification("Can't find Four Play.")
        utility.wait(0.1)
    Else
        FP_API = FP_MainQuest as four_play:Main
        ;RegisterForCustomEvent(FP_API, "animation_start")
        ;RegisterForCustomEvent(FP_API, "animation_change")
        RegisterForCustomEvent(FP_API, "animation_over")
    Endif
EndFunction

Function Update()
	;Script Registers Update
	RegisterForRemoteEvent(Game.GetPlayer(), "OnPlayerLoadGame")
	;Slave Collections Update
	int index = 0
	While index < JBSlaveCollection.GetCount()
		Actor Slave = JBSlaveCollection.GetActorAt(index)
		If (Slave.GetValue(JBIsWorkStatus) == 3) && (JBSlaveFollowersCollection.Find(Slave) < 0)
			JBSlaveFollowersCollection.addRef(Slave)
			Slave.EvaluatePackage()
		ElseIf (GetWorkshopID(Slave) > -1) && (JBWorkshopSlaveCollection.Find(Slave) < 0)
			JBWorkshopSlaveCollection.addRef(Slave)
			Slave.EvaluatePackage()
		Else
			Slave.EvaluatePackage()
		EndIf
		index += 1
	EndWhile
	Utility.Wait(0.5)
	;Caravan Slave Collections Update
	index = 0
	While index < JBSlaveCollection.GetCount()
		Actor Slave = JBSlaveCollection.GetActorAt(index)
		If (WorkshopParent.CaravanActorAliases.Find(Slave) > -1) && (JBCaravanSlaveCollection.Find(Slave) < 0)
			JBCaravanSlaveCollection.addRef(Slave)
			Slave.EvaluatePackage()
		Else
			Slave.EvaluatePackage()
		EndIf
		index += 1
	EndWhile
	Utility.Wait(0.5)
	;Slave Followers Update
	index = 0
	While index < JBSlaveFollowersCollection.GetCount()
		Actor SlaveFollower = JBSlaveFollowersCollection.GetActorAt(index)
		If IsSlaveFollower(SlaveFollower) == -1
			int emptyIndex = GetEmptySlaveFollowerIndex()
			If emptyIndex == -1
				JBSlaveFollowersCollection.RemoveRef(SlaveFollower)
				SlaveFollower.SetValue(JBIsWorkStatus, 4)
				SetCommandMode(SlaveFollower, false)
				SlaveFollower.EvaluatePackage()
			Else
				JBSlaveFollower[emptyIndex].ForceRefTo(SlaveFollower)
				SlaveFollower.EvaluatePackage()
			EndIf
		EndIf
		index += 1
	EndWhile
	Utility.Wait(0.5)
	;Slave Wound and LocRefType Update
	index = 0
	While index < JBSlaveCollection.GetCount()
		Actor Slave = JBSlaveCollection.GetActorAt(index)
		If IsWounded(Slave)
			WoundSlave(Slave, false)
			Slave.EvaluatePackage()
		EndIf
		If GetWorkshopID(Slave) > -1
			Location slaveLocation = WorkshopParent.GetWorkshop(GetWorkshopID(Slave)).myLocation
			SetAsBoss(Slave, slaveLocation)
		EndIf
		index += 1
	EndWhile

	If (Game.GetPlayer().HasPerk(JBHuntingPerk))
		JBbIsHunterModeActivated = true
	Else
		JBbIsHunterModeActivated = false
	EndIf
	If (Game.GetPlayer().HasPerk(JBRenamePerk))
		JBbIsRenameModeActivated = true
	Else
		JBbIsRenameModeActivated = false
	EndIf
	If (Game.GetPlayer().HasPerk(JBTradePerk))
		JBbIsTradeModeActivated = true
	Else
		JBbIsTradeModeActivated = false
	EndIf

	if (Game.GetPlayer().GetItemCount(JBSCSHolotape) == 0)
		Game.GetPlayer().AddItem(JBSCSHolotape)
	endIf

	JBUpdateMSG.Show()
EndFunction

;********************************************************************************************************
;****************************************Debug functions*************************************************
;********************************************************************************************************

function jbTrace(string traceString, int severity = 0, bool bNormalTraceAlso = false) DebugOnly
	debug.traceUser(userlogName, " " + traceString, severity)
;	if bNormalTraceAlso
;		;debug.Trace(self + " " + traceString, severity)
;	endif
endFunction

Function OpenLog()
	debug.OpenUserLog(userlogName)
EndFunction
