Scriptname JB:JBTradeQuestScript extends Quest Conditional


JB:JBSlaveQuestScript Property JBSlaveQuest Auto Const Mandatory

Perk Property JBTradePerk Auto Const Mandatory

RefCollectionAlias Property JBSlaveFollowersCollection Auto Const
RefCollectionAlias Property JBSlavesSoldCollection Auto Const

ReferenceAlias Property Customer Auto Const
ReferenceAlias Property Product Auto Const

Message Property JBTradeModeON Auto Const
Message Property JBTradeModeOFF Auto Const
Message Property JBSlaveCostMSG Auto Const

Scene Property JBTradeScene01 Auto Const

MiscObject Property Caps001 Auto Const

Int Property JBSlaveCost Auto

Function JBTradeModeSwitch()
	;If !Utility.IsInMenuMode() && !Game.GetPlayer().IsDead()
		Utility.Wait(0.1)
		If (Game.GetPlayer().HasPerk(JBTradePerk))
			Game.GetPlayer().RemovePerk(JBTradePerk)
			JBSlaveQuest.JBbIsTradeModeActivated = false
			JBTradeModeOFF.Show()
		Else
			Game.GetPlayer().AddPerk(JBTradePerk)
			JBSlaveQuest.JBbIsTradeModeActivated = true
			JBTradeModeON.Show()
		EndIf
	;EndIf
EndFunction

Function StartTrade(Actor akActor)
	Customer.ForceRefTo(akActor)
	JBTradeScene01.Start()
EndFunction

Function ToOfferSlave()
	Actor Slave = Product.GetActorRef()
	int aliasIndex = JBSlaveQuest.IsSlaveFollower(Slave)
	If aliasIndex != -1
		If JBSlaveQuest.bAllowTeleportToInstitute
			JB:JBSlaveFollowerScript Follower = JBSlaveQuest.JBSlaveFollower[aliasIndex] as JB:JBSlaveFollowerScript
			Follower.UnregisterForPlayerTeleport()
		EndIf
		JBSlaveQuest.JBSlaveFollower[aliasIndex].Clear()
	EndIf
	JBSlaveQuest.SetCommandMode(Slave, false)
	JBSlaveQuest.JBSlaveCollection.RemoveRef(Slave)
	JBSlaveQuest.JBSlaveFollowersCollection.RemoveRef(Slave)
	Slave.RemoveFromFaction(JBSlaveQuest.JBSlaveFaction)
	Slave.SetActivateTextOverride(None)
	Game.GetPlayer().AddItem(Caps001, JBSlaveCost)
	JBSlaveQuest.RemoveFromSale()
	JBSlavesSoldCollection.AddRef(Slave)
	Slave.EvaluatePackage()
EndFunction

Function OfferForSale(Actor akActor)
	Product.ForceRefTo(akActor)
	CalculateCostSlave(akActor)
	JBSlaveQuest.availableForSale = true
EndFunction

; Function RemoveFromSale()
; 	Product.Clear()
; 	JBSlaveQuest.availableForSale = false
; EndFunction

Function CalculateCostSlave(Actor akActor)
	float submissiveValue = Math.Sqrt(akActor.GetValue(JBSlaveQuest.JBIsSubmissive))
	float sexValue = Math.Sqrt(akActor.GetValue(JBSlaveQuest.JBSlaveSexSkill))
	float prostituteValue = Math.Sqrt(akActor.GetValue(JBSlaveQuest.JBSlaveProstituteSkill))
	int cost = 100 * Math.Ceiling(submissiveValue + sexValue + prostituteValue)
	If cost <= 0
		cost = 100
	EndIf
	JBSlaveCost = cost
	Debug.Notification((JBSlaveCostMSG as Form).GetName()+" - "+JBSlaveCost)
EndFunction
